//初期設定
void setup() {
  // PWMピンを出力に設定
  pinMode(5, OUTPUT);
  pinMode(6, OUTPUT);
  pinMode(9, OUTPUT);
  pinMode(10, OUTPUT);

  Serial.begin(38400); //シリアル通信を初期化する。
}

//センサの値を保存する変数
int sensorL0, sensorR0;
int sensorL2, sensorR2;

//メイン処理
void loop() {
  sensor_update();

  //左右両方白線
  //前進
  if( (sensorL0 < 700) && (sensorR0 < 700)){
    motor_left_forward();   //左車輪：前進
    motor_right_forward();  //左車輪: 前進
    delay(50);
  }

  //L0が黒、R0が白。
  //右側に進む
  if( (sensorL0 >= 700) && (sensorR0 < 700)){
    motor_left_stop();     //左車輪： 停止
    motor_right_forward(); //右車輪: 前進

    delay(50);
  }
  
  //L0が白、R0が黒。
  //左側に進む。
  if( (sensorL0 < 700) && (sensorR0 >= 700)){

    motor_left_forward(); //左車輪：前進
    motor_right_stop();   //右車輪: 停止
    delay(50);
  }

  sensor_update();
  //L2が黒、R2が白。
  //左側に旋回する。
  if( (sensorL2 >= 700) && (sensorR2 < 700)){
    motor_left_back();     //左車輪: 後退
    motor_right_forward(); //右車輪: 前進

    delay(50);
  }

  //R2が黒、L2が白。
  //右側に旋回する。
  if( (sensorL2 < 700) && (sensorR2 >= 700)){

    motor_left_forward();  //左車輪：前進
    motor_right_back();    //右車輪: 後退
    delay(50);
  }


  sensor_update();
  //両方黒線、黒線の上に乗っている
  //後退する
  if( (sensorL0 >= 700) && (sensorR0 >= 700)){

    motor_left_back();  //左車輪: 後退
    motor_right_back(); //右車輪: 前進
    delay(100);
  }


  motor_left_stop();
  motor_right_stop();
  delay(100); 

}

void motor_left_forward(void){
    analogWrite(6, 0); //Left Motor 正転
    analogWrite(5, 150);   

}

void motor_left_back(void){
    analogWrite(6, 150); //Left Motor 正転
    analogWrite(5, 0);   

}

void motor_left_stop(void){
    analogWrite(6, 0); //Left Motor 停止
    analogWrite(5, 0);   

}

void motor_right_forward(void){
    analogWrite(9, 0); //right Motor 正転
    analogWrite(10, 150);   

}

void motor_right_back(void){
    analogWrite(9, 150); //right Motor 逆転
    analogWrite(10, 0);   

}


void motor_right_stop(void){
    analogWrite(9, 0); //right Motor 停止
    analogWrite(10, 0);   

}

//センサの値を読み込む
void sensor_update(void){
  sensorL0 = analogRead(A0);
  sensorR0 = analogRead(A1);
  sensorL2 = analogRead(A2);
  sensorR2 = analogRead(A3);

}
