//distance_sensor_main.c

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdbool.h>
#include <signal.h>
#include <unistd.h>

#include <pigpio.h>

#include "control_common.h"
#include "control_distance_sensor.h"


//シグナルハンドラ関数(sigint)
static void sigint_handler(int signum);

#define ONE_CYCLE_MS (50)

int main(void)
{
    //sigaction構造体用変数
    struct sigaction act, oldact;
    int distance_cm;
    unsigned int count;


    //pigpio初期化
    if(gpioInitialise() < 0){
        printf("pigpio initialize error. \n");
        exit(-1);
    }

    distance_sensor_init();

    //Ctrl+Cを押した時にシグナルハンドラを実行する
	act.sa_handler = sigint_handler;
	//SIGINT 受信時に動作する
	sigaction(SIGINT, &act, &oldact);

    while(1){
        sleep_ms(ONE_CYCLE_MS);
        distance_cm = distance_sensor_get_distance();
        printf("%5d, %4d cm\n", count, distance_cm);

        count ++;
    }


}

//シグナルハンドラ関数(sigint)
void sigint_handler(int signum)
{
    terminate_distance_sensor();
    gpioTerminate();  
    exit(0);
}

