//motor_main.c

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdbool.h>
#include <signal.h>
#include <unistd.h>

#include <pigpio.h>

#include "control_common.h"
#include "control_motor.h"


//シグナルハンドラ関数(sigint)
static void sigint_handler(int signum);

#define ONE_CYCLE_MS (50)

int main(void)
{
    //sigaction構造体用変数
    struct sigaction act, oldact;
    int duty = 0;
    //pigpio初期化
    if(gpioInitialise() < 0){
        printf("pigpio initialize error. \n");
        exit(-1);
    }

    motor_init();

    //Ctrl+Cを押した時にシグナルハンドラを実行する
	act.sa_handler = sigint_handler;
	//SIGINT 受信時に動作する
	sigaction(SIGINT, &act, &oldact);

    while(1){
        for(duty = 0; duty < 100; duty ++){
            //前進
            motor_set_speed_left(duty);
            motor_set_speed_right(duty);

            printf("LEFT and RIGHT motor FORWARD: %3d% .\n ", duty);

            sleep_ms(ONE_CYCLE_MS);
        }
        for(duty = 100; duty > 0; duty --){
            //前進
            motor_set_speed_left(duty);
            motor_set_speed_right(duty);

            printf("LEFT and RIGHT motor FORWARD: %3d% .\n ", duty);

            sleep_ms(ONE_CYCLE_MS);
        }
        for(duty = 0; duty > -100; duty --){
            //後退
            motor_set_speed_left(duty);
            motor_set_speed_right(duty);

            printf("LEFT and RIGHT motor BACKWARD: %3d% .\n ", duty);

            sleep_ms(ONE_CYCLE_MS);
        }
        for(duty = -100; duty < 0; duty ++){
            //後退
            motor_set_speed_left(duty);
            motor_set_speed_right(duty);

            printf("LEFT and RIGHT motor BACKWARD: %3d% .\n ", duty);

            sleep_ms(ONE_CYCLE_MS);
        }

    }


}

//シグナルハンドラ関数(sigint)
void sigint_handler(int signum)
{
    motor_set_speed_left(0);
    motor_set_speed_right(0);
    
    gpioTerminate();  
    exit(0);
}

