//control_common.c
//複数のモジュールから共通して呼ばれる処理に関するモジュール

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <stdbool.h>
#include <signal.h>
#include <unistd.h>
#include <math.h>

#include <fcntl.h>
#include <sys/ioctl.h>
#include <linux/spi/spidev.h>
#include <sys/time.h>

#include "control_common.h"

//時刻を表す文字列の最大長さ
#define TIME_STR_MAX (128)


//指定された時間(ms)休止する
void sleep_ms(unsigned int ms) {
    struct timespec req = {0};
    req.tv_sec = 0;              // 秒
    req.tv_nsec = ms * 1000000;  // 10ミリ秒 = 10,000,000ナノ秒
    nanosleep(&req, NULL);
}

//指定された時間(μs)休止する
void sleep_us(unsigned int us) {
    struct timespec req = {0};
    req.tv_sec = 0;              // 秒
    req.tv_nsec = us * 1000;  // 10ミリ秒 = 10,000,000ナノ秒
    nanosleep(&req, NULL);
}

//現在時刻を文字列で取得する
void get_time_now(char *time_str){
    struct timeval tv;
    int millisec;
    struct tm* tm_info;
    char buffer[26];

    
        gettimeofday(&tv, NULL);

        millisec = lrint(tv.tv_usec / 1000.0); // マイクロ秒をミリ秒に変換
        if (millisec >= 1000) { // ミリ秒が1000を超えた場合は秒に繰り上げ
            millisec -= 1000;
            tv.tv_sec++;
        }

        tm_info = localtime(&tv.tv_sec);
        strftime(buffer, 26, "%Y-%m-%d %H:%M:%S", tm_info);
        snprintf(time_str,TIME_STR_MAX, "%s.%03d", buffer, millisec); // フォーマットされた時刻とミリ秒を出力

}


