//control_common.c
//複数のモジュールから共通して呼ばれる処理を記述する

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdbool.h>
#include <signal.h>
#include <unistd.h>

#include "control_common.h"

//指定された時間(ms)休止する
//休止している間、別のスレッドまたはタスクが実行可能
void sleep_ms(unsigned int ms) {
    struct timespec req;
    req.tv_sec = 0;              // 秒
    req.tv_nsec = ms * 1000*1000;  // ms(ミリ秒) =  ms * 1000(us) * 1000(ns)
    nanosleep(&req, NULL);
}

//指定された時間(μs)休止する
void sleep_us(unsigned int us) {
    struct timespec req = {0};
    req.tv_sec = 0;              // 秒
    req.tv_nsec = us * 1000;  // 10ミリ秒 = 10,000,000ナノ秒
    nanosleep(&req, NULL);
}

