//write_pcal9555apw_main.c

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdbool.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>

#include <sys/ioctl.h>
#include <linux/i2c-dev.h>

#include <stdlib.h>

#include "control_common.h"

//PCAL9555APWのI2Cアドレス
#define ADDR_PCAL9555APW (0x20)


#define I2C_DEV_FILE "/dev/i2c-1"  // Raspberry PiのI2Cデバイスファイル


void i2c_write_byte(unsigned char addr, unsigned char reg_addr, unsigned char data);


int main(void){
    unsigned char pattern = 0b00000001;
    
    i2c_write_byte(ADDR_PCAL9555APW, 0x06, 0x00);  //port0をすべて出力(0)
    i2c_write_byte(ADDR_PCAL9555APW, 0x02, 0b00000000); //port0をすべて消灯(Low:0)
    while(1){
        i2c_write_byte(ADDR_PCAL9555APW, 0x02, pattern);

        pattern <<= 1;
        if(pattern == 0b0000000){
            pattern = 0b00000001;
        }
        printf(".");
        fflush(stdout);
        sleep_ms(100);
    }

    return(0);
}


    

//I2Cデバイスに1byte書き込む
void i2c_write_byte(unsigned char addr, unsigned char reg_addr, unsigned char data){
    int file;
    char buf[2] = {reg_addr, data};  // 送信するコマンドとデータ

    // I2Cデバイスを開く
    if ((file = open(I2C_DEV_FILE, O_RDWR)) < 0) {
        perror("Failed to open the i2c bus");
        exit(1);
    }

    // I2Cスレーブデバイスのアドレスを設定
    if (ioctl(file, I2C_SLAVE, addr) < 0) {
        perror("Failed to acquire bus access and/or talk to slave");
        close(file);
        exit(1);
    }

    // データを送信
    if (write(file, buf, 2) != 2) {
        perror("Failed to write to the i2c bus");
        close(file);
        exit(1);
    }

    close(file);   //デバイスファイルを閉じる

    sleep_us(10);   //連続アクセスに備えて、10usのウェイトを入れておく


}
