
#ifndef VEHICLE_CONTROL_COMMUNICATION_H
#define VEHICLE_CONTROL_COMMUNICATION_H

//UDPパケットのpayload想定長さ(byte)
#define UDP_PAYLOAD_LENGTH_MAX (256)

//制御パケットの先頭文字列
#define REMOTE_PACKET_PREFIX "REMOTE"
//制御パケットの最後の子フィールドの値(固定値)
#define REMOTE_PACKET_SUFFIX (9876)

void communication_init(void);      //このモジュールを初期化する
bool is_new_packet_exists(void);    //新たなパケットがあるか
void communication_get_new_data(char *data);    //直近に到着したパケットを取得する
void terminate_communication(void); //スレッドを終了させる。

#endif