#ifndef VEHICLE_CONTROL_GPIO_IN_H
#define VEHICLE_CONTROL_GPIO_IN_H

//GPIOの名前を列挙型で宣言
typedef enum {
    RAW_GPIO_INPUT_START = 0,
    RAW_GPIO_SW_P0=0, RAW_GPIO_SW_P1, RAW_GPIO_SW_P2,
    RAW_GPIO_RS_DIGITAL_OUT_L0, RAW_GPIO_RS_DIGITAL_OUT_L1,
    RAW_GPIO_RS_DIGITAL_OUT_R0, RAW_GPIO_RS_DIGITAL_OUT_R1,
    RAW_GPIO_SW_T0, RAW_GPIO_SW_T1,
    RAW_GPIO_GPIO_INPUT_MAX
} e_gpio_input;

//SWの名前を列挙体で宣言
typedef enum {
    SW_INPUT_START = 0,
    SW_P0=0, SW_P1, SW_P2,
    RS_DIGITAL_OUT_L0, RS_DIGITAL_OUT_L1,
    RS_DIGITAL_OUT_R0, RS_DIGITAL_OUT_R1,
    SW_T0, SW_T1,
    SW_INPUT_MAX
} e_sw_input;

//スイッチの状態を列挙体で宣言
typedef enum {SW_OFF, SW_ON, SW_TOGGLED_ON, SW_TOGGLED_OFF} e_sw_state;

void gpio_in_init(void);        //このモジュールを初期化する
void terminate_gpio_in(void);   //スレッドを終了する

int gpio_in_get_state_raw(e_gpio_input port);       //GPIOの状態を取得する
e_sw_state gpio_in_get_sw_state(e_sw_input sw);     //スイッチの状態を取得する

#endif