//vehicle_control_main

#include "common.h"
#include "read_sw.h"
#include "vehicle_control_main.h"
#include "gpio.h"
#include "motor.h"
#include "vehicle_control_main_remote.h"

typedef enum {
	VEHICLE_REMOTE_CONTROL_MODE,
	VEHICLE_LINE_TRACING_MODE,
	NUMBER_OF_VEHICLE_MODE
	
} e_vehicle_mode;

e_vehicle_mode vehicle_mode;


void vehicle_control_main_init(void)
{
	
	/* gOXCb`T0̈ʒuŁAremoteline_tracing؂ւ */
	if(gpio_get_raw_port_level(PORT_SW_T1) == GPIO_LOW){
		lcd_set_message(1, "MOTOR: POLOLU");
		set_motor_type(MOTOR_TYPE_POLOLU);
	} else {
		lcd_set_message(1, "MOTOR: TSUKASA");
		set_motor_type(MOTOR_TYPE_TSUKASA);
	}

	if(gpio_get_raw_port_level(PORT_SW_T0) == GPIO_LOW){
		lcd_set_message(0, "LineTracingMode");
		vehicle_mode = VEHICLE_LINE_TRACING_MODE;
		vehicle_control_main_line_tracing_init();
	} else {
		lcd_set_message(0, "RemoteControlMode");
		vehicle_mode = VEHICLE_REMOTE_CONTROL_MODE;
		vehicle_control_main_remote_init();
	}
	

	return;
}

void vehicle_control_main_slot_a(void)
{
	switch(vehicle_mode){
	case VEHICLE_LINE_TRACING_MODE:
		vehicle_control_main_line_tracing_slot_a();
		break;
	case VEHICLE_REMOTE_CONTROL_MODE:
		vehicle_control_main_remote_slot_a();
		
		break;
	default:
	
		break;
		
	}

	
	
	return;
}


void vehicle_control_main_slot_b(void)
{
	switch(vehicle_mode){
	case VEHICLE_LINE_TRACING_MODE:
		vehicle_control_main_line_tracing_slot_b();
		break;
	case VEHICLE_REMOTE_CONTROL_MODE:
		vehicle_control_main_remote_slot_b();
		
		break;
	default:
	
		break;
		
	}
	
	return;
}

void vehicle_control_main_slot_c(void)
{

	switch(vehicle_mode){
	case VEHICLE_LINE_TRACING_MODE:
		vehicle_control_main_line_tracing_slot_c();
		break;
	case VEHICLE_REMOTE_CONTROL_MODE:
		vehicle_control_main_remote_slot_c();
		
		break;
	default:
	
		break;
		
	}
	return;
}
