//acd.c

#include "../iodefine.h"
#include "common.h"

#include "adc.h"
#include "timer.h"

#define AD_FILTER_LENGTH (10)
static UINT8 filter_pos;
static UINT16 ad_filter_buffer[END_OF_e_ad_port_name][AD_FILTER_LENGTH];
static UINT16 ad_filtered_value[END_OF_e_ad_port_name];
/*
  AN100: VR0
  AN101: VR1
  AN102: VR2
  AN103: VBATT_WATCH
  
  S12AD1W[p

*/

static UINT16 ad_raw_value[END_OF_e_ad_port_name];

static UINT16 get_ad_raw_value(e_ad_port_name port);

//ADC̏
void adc_init(void)
{
	UINT16 port, pos;
	
	filter_pos = 0;
	
	for(port = 0; port < END_OF_e_ad_port_name; port ++){
		ad_raw_value[port] = 0;	
		ad_filtered_value[port] = 0;
	}
	
	for(port = START_OF_e_ad_port_name; port < END_OF_e_ad_port_name; port ++){
		for(pos = 0; pos <= AD_FILTER_LENGTH; pos ++){
			ad_filter_buffer[port][pos] = 0;
		}		
	}
	//VR_OUT->P40(AN000)
	
	//ADϊjbg(S12AD, S12AD1)𓮍JnB
	SYSTEM.PRCR.WORD = 0xA502;		// MSTPCRAWX^veNg̉
	SYSTEM.MSTPCRA.BIT.MSTPA17 = 0;         // S12AD̃W[Xgbv̉
	SYSTEM.MSTPCRA.BIT.MSTPA16 = 0;		// S12AD1̃XgbvԂ̉
	SYSTEM.PRCR.WORD = 0xA500;		// MSTPCRAWX^veNg̐ݒ
	
	/* ˃ZT */
	PORT4.PDR.BIT.B0=1;	//͒[qƂĎgp
	PORT4.PDR.BIT.B1=1;
	PORT4.PDR.BIT.B2=1;
	PORT4.PDR.BIT.B3=1;
	PORT4.PDR.BIT.B4=1;	
	PORT4.PDR.BIT.B5=1;
	PORT4.PDR.BIT.B6=1;
	PORT4.PDR.BIT.B7=1;

	PORT4.PMR.BIT.B0=1;	//Ӌ@\ƂĎgp
	PORT4.PMR.BIT.B1=1;
	PORT4.PMR.BIT.B2=1;
	PORT4.PMR.BIT.B3=1;
	PORT4.PMR.BIT.B4=1;
	PORT4.PMR.BIT.B5=1;
	PORT4.PMR.BIT.B6=1;
	PORT4.PMR.BIT.B7=1;

	//ADϊ@\̐ݒ
	MPC.P40PFS.BIT.ASEL = 0x1;	//P4n̒[q@\I(AiO͂Ƃėp)
	MPC.P41PFS.BIT.ASEL = 0x1;
	MPC.P42PFS.BIT.ASEL = 0x1;
	MPC.P43PFS.BIT.ASEL = 0x1;
	MPC.P44PFS.BIT.ASEL = 0x1;			
	MPC.P45PFS.BIT.ASEL = 0x1;
	MPC.P46PFS.BIT.ASEL = 0x1;
	MPC.P47PFS.BIT.ASEL = 0x1;

	
	S12AD.ADCSR.BIT.ADCS = 0x2;	//XL[hAL[hƂ
		
	S12AD.ADANSA0.BIT.ANSA000 = 0x1;	//AN000ϊΏۂƂ
	S12AD.ADANSA0.BIT.ANSA001 = 0x1;	//AN001ϊΏۂƂ
	S12AD.ADANSA0.BIT.ANSA002 = 0x1;	//AN002ϊΏۂƂ
	S12AD.ADANSA0.BIT.ANSA003 = 0x1;	//AN003ϊΏۂƂ
	S12AD.ADANSA0.BIT.ANSA004 = 0x1;	//AN004ϊΏۂƂ
	S12AD.ADANSA0.BIT.ANSA005 = 0x1;	//AN005ϊΏۂƂ
	S12AD.ADANSA0.BIT.ANSA006 = 0x1;	//AN006ϊΏۂƂ
	S12AD.ADANSA0.BIT.ANSA007 = 0x1;	//AN007ϊΏۂƂ
		
	S12AD.ADCER.BIT.ADPRC = 0x0;		//ϊx12bitƂ
	
	S12AD.ADADS0.BIT.ADS000=1;//AN000̉Zσ[hLɂ
	S12AD.ADADC.BIT.ADC=0x5;//16Z(ADC[2:0]=101)B
	S12AD.ADADC.BIT.AVEE=0x1;//σ[h(AVEE=1)I
	
	S12AD.ADCSR.BIT.ADST = 0x1;			//ADϊJn

	
	/*VR0, VR1, VR2, VBATT_WATCH */
	PORTE.PDR.BIT.B2=1;	//͒[qƂĎgp
	PORTE.PDR.BIT.B3=1;
	PORTE.PDR.BIT.B4=1;
	PORTE.PDR.BIT.B5=1;

	PORTE.PMR.BIT.B2=1;	//Ӌ@\ƂĎgp
	PORTE.PMR.BIT.B3=1;
	PORTE.PMR.BIT.B4=1;
	PORTE.PMR.BIT.B5=1;

	//ADϊ@\̐ݒ
	MPC.PE2PFS.BIT.ASEL = 0x1;		//PEn̒[q@\I(AiO͂Ƃėp)
	MPC.PE3PFS.BIT.ASEL = 0x1;
	MPC.PE4PFS.BIT.ASEL = 0x1;
	MPC.PE5PFS.BIT.ASEL = 0x1;

	S12AD1.ADCSR.BIT.ADCS = 0x2;		//XL[hAL[hƂ
		
	S12AD1.ADANSA0.BIT.ANSA000 = 0x1;	//AN100ϊΏۂƂ
	S12AD1.ADANSA0.BIT.ANSA001 = 0x1;	//AN101ϊΏۂƂ
	S12AD1.ADANSA0.BIT.ANSA002 = 0x1;	//AN102ϊΏۂƂ
	S12AD1.ADANSA0.BIT.ANSA003 = 0x1;	//AN103ϊΏۂƂ
		
	S12AD1.ADCER.BIT.ADPRC = 0x0;		//ϊx12bitƂ
	
	S12AD1.ADADS0.BIT.ADS000=1;	//AN100̉Zσ[hLɂ
	S12AD1.ADADC.BIT.ADC=0x5;	//16Z(ADC[2:0]=101)B
	S12AD1.ADADC.BIT.AVEE=0x1;	//σ[h(AVEE=1)I
	
	
	
	S12AD1.ADCSR.BIT.ADST = 0x1;			//ADϊJn

	return;
}

//ADl擾
UINT16 get_ad_raw_value(e_ad_port_name port)
{
	//ϊʂi[ϐ
	unsigned int value = 0;
	
	//ϊʂǂݍ
	switch(port){
	case AD_RS_OUT_L0:
		value = S12AD.ADDR0;
		break;
	case AD_RS_OUT_L1:
		value = S12AD.ADDR1;
		break;
	case AD_RS_OUT_L2:
		value = S12AD.ADDR2;
		break;
	case AD_RS_OUT_R0:
		value = S12AD.ADDR3;
		break;
	case AD_RS_OUT_R1:
		value = S12AD.ADDR4;
		break;
	case AD_RS_OUT_R2:
		value = S12AD.ADDR5;
		break;
	case AD_RS_OUT_L3:
		value = S12AD.ADDR6;
		break;
	case AD_RS_OUT_R3:
		value = S12AD.ADDR7;
		break;
	case AD_VR0:
		value = S12AD1.ADDR0;
	
		break;
	case AD_VR1:
		value = S12AD1.ADDR1;

		break;
	case AD_VR2:
		value = S12AD1.ADDR2;

		break;
	case AD_VBATT_WATCH:
		value = S12AD1.ADDR3;
	
		break;
	default:
		break;
	}
	
/*

case AD_RS_OUT_L0:
case AD_RS_OUT_L1:
case AD_RS_OUT_L2:
case AD_RS_OUT_R0:
case AD_RS_OUT_R1:
case AD_RS_OUT_R2:
case AD_RS_OUT_L3:
case AD_RS_OUT_R3:


*/



	return(value);
}


SINT16 adc_get_value_as_volume(e_ad_port_name port){
	return( (((SINT16)adc_get_value(port) / 200) - 20) * 10 + 100);	
}

UINT16 adc_get_value(e_ad_port_name port){
	return(ad_filtered_value[port]);
	//return(ad_raw_value[port]);	
}

UINT16 adc_get_raw_value(e_ad_port_name port){
	
	return(ad_raw_value[port]);	
}


/* ADϊʂWX^ǂݍŃobt@ɕۑ */
void adc_update(void){

	e_ad_port_name port;
	
	for(port = START_OF_e_ad_port_name; port < END_OF_e_ad_port_name; port ++){
		ad_filter_buffer[port][filter_pos] = ad_raw_value[port] = get_ad_raw_value(port);
		
	}
	
	filter_pos ++;
	if( filter_pos >= AD_FILTER_LENGTH ){
		filter_pos = 0;
	}
	
	return;
}

/* ړςl߂ */
void adc_update_filter(void){
	UINT8 port, pos;
	UINT16 value;
	
	
	for(port = START_OF_e_ad_port_name; port < END_OF_e_ad_port_name; port ++){
		value = 0;
		for(pos = 0; pos < AD_FILTER_LENGTH; pos ++){
			value += ad_filter_buffer[port][pos];
		}		
		ad_filtered_value[port] = value / AD_FILTER_LENGTH;
	}
	
}


