//gpio.c
#include "../iodefine.h"
#include "gpio.h"
#include "common.h"

/* |[gxۑ邽߂̃WX^ */
BYTE output_port_level[END_OF_OUTPUT_PORT];
BYTE input_port_level[END_OF_INPUT_PORT];

void gpio_init(void){
	e_output_port_name output_port;
	e_input_port_name  input_port;
	/*LED֘A*/
	/* , |[gݒ, o(1) */
	PORTC.PDR.BIT.B4 = 1; 	/*LED_ST0	PC4*/
	PORTC.PDR.BIT.B5 = 1; 	/*LED_ST1	PC5*/
	PORTC.PDR.BIT.B6 = 1; 	/*LED_ST2	PC6*/
	
	PORTE.PDR.BIT.B0 = 1; 	/*LED_IND0	PE0*/	
	PORTE.PDR.BIT.B1 = 1; 	/*LED_IND1	PE1*/	
	PORTA.PDR.BIT.B0 = 1; 	/*LED_IND2	PA0*/	
	PORTA.PDR.BIT.B1 = 1; 	/*LED_IND3	PA1*/	
	PORTB.PDR.BIT.B4 = 1; 	/*LED_IND4	PB4*/	
	PORTB.PDR.BIT.B5 = 1; 	/*LED_IND5	PB5*/	
	PORTB.PDR.BIT.B6 = 1; 	/*LED_IND6	PB6*/	
	PORTB.PDR.BIT.B7 = 1; 	/*LED_IND7	PB7*/	

	PORT0.PDR.BIT.B7 = 1; 	/*PORT_DISTANCE_SENSOR_TRIG	P07*/	

	/* ŏ̃|[go: 0:_, 1: */
	PORTC.PODR.BIT.B4 = 1; 	/*LED_ST0	PC4*/
	PORTC.PODR.BIT.B5 = 1; 	/*LED_ST1	PC5*/
	PORTC.PODR.BIT.B6 = 1; 	/*LED_ST2	PC6*/
	
	PORTE.PODR.BIT.B0 = 1; 	/*LED_IND0	PE0*/	
	PORTE.PODR.BIT.B1 = 1; 	/*LED_IND1	PE1*/	
	PORTA.PODR.BIT.B0 = 1; 	/*LED_IND2	PA0*/	
	PORTA.PODR.BIT.B1 = 1; 	/*LED_IND3	PA1*/	
	PORTB.PODR.BIT.B4 = 1; 	/*LED_IND4	PB4*/	
	PORTB.PODR.BIT.B5 = 1; 	/*LED_IND5	PB5*/	
	PORTB.PODR.BIT.B6 = 1; 	/*LED_IND6	PB6*/	
	PORTB.PODR.BIT.B7 = 1; 	/*LED_IND7	PB7*/	

	PORT0.PODR.BIT.B7 = 0; 	/*PORT_DISTANCE_SENSOR_TRIG	P07*/	

	
	/*SW֘A*/
	/* , |[gݒ,  */
	PORTD.PDR.BIT.B0 = 0; 	/* SW_P0	PD0_IRQ0 */
	PORTD.PDR.BIT.B1 = 0; 	/* SW_P1	PD1_IRQ1 */
	PORTD.PDR.BIT.B2 = 0; 	/* SW_P2	PD2_IRQ2 */
	PORTD.PDR.BIT.B3 = 0; 	/* SW_T0	PD3_IRQ3 */
	PORTD.PDR.BIT.B5 = 0; 	/* SW_T1	PD5_IRQ5 */
	
	
	for(output_port = START_OF_OUTPUT_PORT; output_port < END_OF_OUTPUT_PORT; output_port ++){
		output_port_level[output_port] = GPIO_HIGH;
	}
	
	for(input_port = START_OF_INPUT_PORT; input_port < END_OF_INPUT_PORT; input_port ++){
		input_port_level[output_port] = GPIO_HIGH;
	}
	return;
}



void update_output_port_level(void){
	e_output_port_name port;
	BYTE level;
	
	for(port = START_OF_OUTPUT_PORT; port < END_OF_OUTPUT_PORT; port ++){
			level = output_port_level[port];
			gpio_set_raw_port_level(port, level);
	}
	return;
}

void update_input_port_level(void){
	e_input_port_name port;
	BYTE level;
	
	for(port = START_OF_INPUT_PORT; port < END_OF_INPUT_PORT; port ++){
			level = gpio_get_raw_port_level(port);
			input_port_level[port] = level;
	}
	return;
}

BYTE gpio_get_port_level(e_input_port_name port){
	return(input_port_level[port]);
}

void gpio_set_port_level(e_output_port_name port, BYTE level)
{
	output_port_level[port] = level;
	
	return;
}


BYTE gpio_get_raw_port_level(e_input_port_name port)
{
	unsigned char level = 0;
	switch(port){
	case PORT_SW_P0:
		level = PORTD.PIDR.BIT.B0;
		break;
	case PORT_SW_P1:
		level = PORTD.PIDR.BIT.B1;
		break;
	case PORT_SW_P2:
		level = PORTD.PIDR.BIT.B2;
		break;
	case PORT_SW_T0:
		level = PORTD.PIDR.BIT.B3;
		break;
	case PORT_SW_T1:
		level = PORTD.PIDR.BIT.B5;
		break;

		
	default:
		level = GPIO_LOW;
		break;
	}
	return level;
}


void gpio_set_raw_port_level(e_output_port_name port, BYTE level){
	switch(port){
	case PORT_LED_IND0:
		PORTE.PODR.BIT.B0 = level;
		break;
	case PORT_LED_IND1:
		PORTE.PODR.BIT.B1 = level;
		break;
	case PORT_LED_IND2:
		PORTA.PODR.BIT.B0 = level;
		break;
	case PORT_LED_IND3:
		PORTA.PODR.BIT.B1 = level;
		break;
	case PORT_LED_IND4:
		PORTB.PODR.BIT.B4 = level;
		break;
	case PORT_LED_IND5:
		PORTB.PODR.BIT.B5 = level;
		break;
	case PORT_LED_IND6:
		PORTB.PODR.BIT.B6 = level;
		break;
	case PORT_LED_IND7:
		PORTB.PODR.BIT.B7 = level;
		break;
	case PORT_LED_ST0:
		PORTC.PODR.BIT.B4 = level;
		break;
	case PORT_LED_ST1:
		PORTC.PODR.BIT.B5 = level;
		break;
	case PORT_LED_ST2:
		PORTC.PODR.BIT.B6 = level;
		break;
	case PORT_DISTANCE_SENSOR_TRIG:
		PORT0.PODR.BIT.B7 = level;
		break;

	default:
		/* do nothing */
		break;
		
	}
	
	return;
}
