//gpio.h
#ifndef GPIO_H
#define GPIO_H

#include "..\main\common.h"

void gpio_init(void);

#define GPIO_HIGH	(1)
#define	GPIO_LOW	(0)

#define PORT_HIGH	(1)
#define	PORT_LOW	(0)

typedef enum input_port_name {
	START_OF_INPUT_PORT = 0,
	PORT_SW_P0 = 0,
	PORT_SW_P1,
	PORT_SW_P2,
	PORT_SW_T0,
	PORT_SW_T1,
	END_OF_INPUT_PORT

} e_input_port_name;


typedef enum output_port_name{
	START_OF_OUTPUT_PORT = 0,
	PORT_LED_ST0 = 0,
	PORT_LED_ST1,
	PORT_LED_ST2,
	PORT_LED_IND0,
	PORT_LED_IND1,
	PORT_LED_IND2,
	PORT_LED_IND3,
	PORT_LED_IND4,
	PORT_LED_IND5,
	PORT_LED_IND6,
	PORT_LED_IND7,
	END_OF_OUTPUT_PORT,
	PORT_DISTANCE_SENSOR_TRIG
} e_output_port_name;

BYTE gpio_get_port_level(e_input_port_name port);
void gpio_set_port_level(e_output_port_name port, BYTE level);
void update_input_port_level(void);
void update_output_port_level(void);
void gpio_set_raw_port_level(e_output_port_name port, BYTE level);
BYTE gpio_get_raw_port_level(e_input_port_name port);

#endif