//i2c.c

#include "../iodefine.h"
#include "common.h"
#include "i2c.h"

/* I2C 0 g */


//AđMt[(X[uAhX܂)̏l
#define I2C_SEND_FRAME_COUNT_MAX	(16)

//[vɂ҂̃[v񐔃JE^̏l
#define RECIEVE_LOOP_COUNT_MAX  (5000)
#define SEND_LOOP_COUNT_MAX     (5000)


//I2C@\̏
void i2c_init(void)
{
	//I2CW[̃W[Xgbvԉ
	SYSTEM.PRCR.WORD = 0xA502;			// MSTPCRAWX^veNg̉
	SYSTEM.MSTPCRB.BIT.MSTPB21 = 0x0;	// RIIC0̃XgbvԂ̉
	SYSTEM.PRCR.WORD = 0xA500;			// MSTPCRAWX^veNg̐ݒ
	
	//PORT12, PORT13g߂̐ݒ
	PORT1.PDR.BIT.B2  = 0x1;  //o͕: OUTPUT
	PORT1.PDR.BIT.B3  = 0x1;
	
	PORT1.PODR.BIT.B2  = 0x1; //o̓x: HIGH
	PORT1.PODR.BIT.B3  = 0x1;

	PORT1.PMR.BIT.B2  = 0x1;  //Ӌ@\I: Ӌ@\
	PORT1.PMR.BIT.B3  = 0x1;
	
	PORT1.PCR.BIT.B2  = 0x0;  //vAbv: Ȃ
	PORT1.PCR.BIT.B3  = 0x0;
	
	PORT1.ODR0.BIT.B4 = 0x1; //I[vhCݒ: N`l
	PORT1.ODR0.BIT.B6 = 0x1; //rbgzu̓}jAQ

		
	PORT1.DSCR2.BIT.B2 = 1; //C^tF[Xp쓮o
	PORT1.DSCR2.BIT.B3 = 1;
	
	
	//P12, P13 SCL0, SDA0ƂĎgpݒ
	MPC.PWPR.BIT.B0WI  = 0x0;  //PFSWErbg݋
	MPC.PWPR.BIT.PFSWE = 0x1;  //PFSWX^݋
	
	MPC.P12PFS.BIT.ISEL = 0x0;	//IRQ͒[qƂĎgpȂ
	MPC.P12PFS.BIT.PSEL = 0x0F;	//Ӌ@\I
	MPC.P13PFS.BIT.ISEL = 0x0;	//IRQ͒[qƂĎgpȂ
	MPC.P13PFS.BIT.PSEL = 0x0F;	//Ӌ@\I

	MPC.PWPR.BIT.PFSWE = 0x0;  //PFSWX^݋֎~
	MPC.PWPR.BIT.B0WI  = 0x1;  //PFSWErbg݋֎~
	
	//I2C@\̏
	RIIC0.ICCR1.BIT.ICE		= 0x0;	//SCL1, SDA1 [q쓮
	RIIC0.ICCR1.BIT.IICRST	= 0x1;	//RIICZbg
	RIIC0.ICCR1.BIT.ICE		= 0x1;	//SCL1, SDA1 [q쓮
	
	
	//ʐMrbg[gݒ
	//PCKLB20MHẑƂA100kbpsƂȂ悤ɐݒ
	RIIC0.ICMR1.BIT.CKS = 0x2;		
	RIIC0.ICBRH.BIT.BRH = 0xF3;		
	RIIC0.ICBRL.BIT.BRL = 0xF7;
	

	RIIC0.ICCR1.BIT.IICRST = 0x0;	//Zbg
}


//I2CfoCX1byte}X^M
unsigned int i2c_master_receive( unsigned char slave_address ,unsigned char *data)
{
	volatile unsigned char dummy;  //ǂݍ񂾌㗘pȂ̂ōœK
	unsigned int result; 
	int loop_count;
	
	loop_count = 0;
	
	
	//I2CoXLmF	
	while(1){
		if( RIIC0.ICCR2.BIT.BBSY == 0x0 ){
			break;	
		}
		
		loop_count ++;  //[vh
		if( loop_count > RECIEVE_LOOP_COUNT_MAX ){
			//񐔂̃[vpŃG[Ƃ
			return I2C_NO_RESPONSE;
		}
	}
	loop_count = 0;  //[vÎŃJE^NA
	
	RIIC0.ICCR2.BIT.ST = 0x1;	//X^[gRfBVs
	
	//Mf[^WX^ł邱ƂmF
	while(1){
		if( RIIC0.ICSR2.BIT.TDRE == 0x01 ){
			break;	
		}
		loop_count ++;  //[vh
		if( loop_count > RECIEVE_LOOP_COUNT_MAX){
			//񐔂̃[vpŃG[Ƃ
			return I2C_NO_RESPONSE;
		}
	}
	loop_count = 0;  //[vÎŃJE^NA
	
	//Mf[^WX^ɑMf[^Zbg
	//X[uAhXR/WtO(Read:1, Write:0)
	RIIC0.ICDRT = (slave_address & 0xFE) << 1 | 0x1;

	
	//Mf[^邱ƂmF
	while(1){
		if( RIIC0.ICSR2.BIT.RDRF == 0x1 ){
			//Mf[^
			break;
		}
		loop_count ++;  //[vh
		if( loop_count > RECIEVE_LOOP_COUNT_MAX ){
			//񐔂̃[vpŃG[Ƃ
			return I2C_NO_RESPONSE;
		}
	}
	loop_count = 0;  //[vÎŃJE^NA
	
	//ACKNACK
	if( RIIC0.ICSR2.BIT.NACKF == 0x0 ){
		//ACKoAI2CfoCX
		RIIC0.ICMR3.BIT.WAIT = 0x1; //WAITɂ
		//Mf[^ǂݏo(_~[[h)
		dummy = RIIC0.ICDRR;
		
		//Mobt@Ƀf[^邩`FbN
		while(1){
			if( RIIC0.ICSR2.BIT.RDRF == 0x1 ){
				//Mf[^
				break;
			}
			loop_count ++;  //[vh
			if( loop_count > RECIEVE_LOOP_COUNT_MAX ){
				//񐔂̃[vpŃG[Ƃ
				return I2C_NO_RESPONSE;
			}
		}
		loop_count = 0;  //[vÎŃJE^NA
		
		//̃f[^ŏI
		//ACKBTݒ: NACKM
		RIIC0.ICMR3.BIT.ACKWP = 0x1;  //CgveNg
		RIIC0.ICMR3.BIT.ACKBT = 0x1;
		RIIC0.ICMR3.BIT.ACKWP = 0x0;  //CgveNgݒ
		
		//Mobt@f[^ǂݏo(f[^t[̃f[^)
		*data = RIIC0.ICDRR;
		
		//Mobt@Ƀf[^邩`FbN
		while(1){
			if( RIIC0.ICSR2.BIT.RDRF == 0x1 ){
				//Mf[^
				break;
			}
			loop_count ++;  //[vh
			if( loop_count > RECIEVE_LOOP_COUNT_MAX ){
				//񐔂̃[vpŃG[Ƃ
				return I2C_NO_RESPONSE;
			}
		}
		loop_count = 0;  //[vÎŃJE^NA
			
		//XgbvRfBVs
		RIIC0.ICSR2.BIT.STOP	= 0x0;
		RIIC0.ICCR2.BIT.SP		= 0x1;

		//Mobt@f[^ǂݏo(_~[[h)
		dummy = RIIC0.ICDRR;
		
		RIIC0.ICMR3.BIT.WAIT = 0x0; //WAITȂɂ
		
		result=0;
		//Mf[^߂lɔf
	} else {
		//NACKoAI2CfoCXȂ
		RIIC0.ICSR2.BIT.STOP	= 0x0;
		RIIC0.ICCR2.BIT.SP		= 0x1;

		//Mobt@_~[f[^ǂݏo
		dummy = RIIC0.ICDRR;
		
		result = I2C_NO_RESPONSE;
	}
	
	//XgbvRfBVsmF
	while(1){
		if( RIIC0.ICSR2.BIT.STOP	== 0x1 ){
		    //XgbvRfBVsς
			break;	
		}
		loop_count ++;  //[vh
		if( loop_count > RECIEVE_LOOP_COUNT_MAX ){
			//񐔂̃[vpŃG[Ƃ
			return I2C_NO_RESPONSE;
		}
	}
	loop_count = 0;  //[vÎŃJE^NA
	
	//ʐM̂߂̏ANACKF, STOPɖ߂
	RIIC0.ICSR2.BIT.NACKF	= 0x0;
	RIIC0.ICSR2.BIT.STOP	= 0x0;
	
	return(result);
}

//I2CfoCX1byte}X^M
unsigned int i2c_master_send( unsigned char slave_address, const unsigned char *data, int size)
{
	
	//Mf[^i[z
	unsigned char send_frames[I2C_SEND_FRAME_COUNT_MAX];
	int frame_count;
	int loop_count;
	int i;
	send_frames[0] = ( slave_address & 0xFE ) << 1 | 0x0;//X[uAhXR/WtO(Read:1, Write:0)
	
	
	for(i=1;i<=size;i++){
		send_frames[i] = data[i-1];//Mf[^
	}
	
	frame_count = 0;
	loop_count = 0;

	//oXLmF
	while(1){
		if( RIIC0.ICCR2.BIT.BBSY == 0x0 ){
			break; //oX̓t[	
		}
		loop_count ++;  //[vh
		if( loop_count > SEND_LOOP_COUNT_MAX ){
			//񐔂̃[vpŃG[Ƃ
			return I2C_NO_RESPONSE;
		}
	}
	loop_count = 0;  //[vÎŃJE^NA
		
	RIIC0.ICCR2.BIT.ST = 0x1;	//X^[gRfBVs
	
	while(1){
		//NACKM?
		if(RIIC0.ICSR2.BIT.NACKF == 0x0){
			//NACKȂApđM\
			frame_count = 0;
			while(1){
				if( RIIC0.ICSR2.BIT.TDRE == 0x1 ){
					//ICDRTWX^ɑMf[^ȂAM\
					//ICDRTCgAMf[^Zbg
					RIIC0.ICDRT = send_frames[frame_count]; 
					frame_count++;
					if(frame_count>size){//SđM
						break;//M
					}
				} else {
					//܂ICDRTWX^ɎcĂ̂ŁA[v̍ŏ蒼
					loop_count++;
					if( loop_count > SEND_LOOP_COUNT_MAX ){
						//񐔂̃[vpŃG[Ƃ
						return I2C_NO_RESPONSE;
					}
				}
			}
		} else {
			//NACKBpăf[^𑗐MłȂ
			//[v𔲂AXgbvRfBVs
			break;
			
		}
		
		//M҂[v
		while(1){
			if( RIIC0.ICSR2.BIT.TEND == 0x1 ){
				//M̂ŁAM҂[v𔲂
				break;	//XgbvRfBVs
			}
			loop_count ++;  //[vh
			if( loop_count > SEND_LOOP_COUNT_MAX ){
				//񐔂̃[vpŃG[Ƃ
				return  I2C_NO_RESPONSE;
			}
		}
		loop_count = 0;  //[vÎŃJE^NA


		break; //XgbvRfBVs
	};
	
	//XgbvRfBVs
	RIIC0.ICSR2.BIT.STOP	= 0x0;
	RIIC0.ICCR2.BIT.SP		= 0x1;	
	

	//XgbvRfBVsmF
	while(1){
		if( RIIC0.ICSR2.BIT.STOP	== 0x1 ){
		    //XgbvRfBVsς
			break;	
		}
		loop_count ++;  //[vh
		if( loop_count > SEND_LOOP_COUNT_MAX ){
			//񐔂̃[vpŃG[Ƃ
			return I2C_NO_RESPONSE;
		}
	}
	loop_count = 0;  //[vÎŃJE^NA


	//ʐM̂߂̏ANACKF, STOPɖ߂
	RIIC0.ICSR2.BIT.NACKF	= 0x0;
	RIIC0.ICSR2.BIT.STOP	= 0x0;
	
	return (0);
}

