//pulse_counter.c
#include "../iodefine.h"
#include "common.h"
#include "pulse_counter.h"

/*
 ENC_MOT_L_A	MTCLKC_P22
 ENC_MOT_L_B	MTCLKD_P23
 ENC_MOT_R_A	MTCLKA_P24
 ENC_MOT_R_B	MTCLKB_P25
*/

static void pulse_counter_MTCLK_AB_init(void);	//RIGHT
static void pulse_counter_MTCLK_CD_init(void);	//LEFT


void pulse_counter_init(void)
{
	//W[Xgbv̉
	SYSTEM.PRCR.WORD = 0xA502;			// MSTPCRAWX^veNg̉
	SYSTEM.MSTPCRA.BIT.MSTPA9 = 0;		// MTU3̃XgbvԂ̉
	SYSTEM.PRCR.WORD = 0xA500;			// MSTPCRAWX^veNg̐ݒ
	
	pulse_counter_MTCLK_AB_init();
	pulse_counter_MTCLK_CD_init();
	
}

// MTU1: MTCLKAB, P24, P25
static void pulse_counter_MTCLK_AB_init(void)
{
	//|[g̐ݒ
	PORT2.PMR.BIT.B4=0;//|[g24ėp|[gƂĎgp
	PORT2.PMR.BIT.B5=0;//|[g25ėp|[gƂĎgp
	
	MPC.PWPR.BIT.B0WI=0;//PFSWEWX^ւ̏݋
	MPC.PWPR.BIT.PFSWE=1;//PFSWX^ւ̏݋
	
	MPC.P24PFS.BIT.PSEL= 0x02;//|[g24MTCLKAƂĎgp
	MPC.P25PFS.BIT.PSEL= 0x02;//|[g25MTCLKBƂĎgp
	
	MPC.PWPR.BIT.PFSWE=0;//PFSWX^ւ̏݋֎~
	MPC.PWPR.BIT.B0WI=1;//PFSWEWX^ւ̏݋֎~
	
	PORT2.PMR.BIT.B4=1;//|[g24ӃW[ƂĎgp
	PORT2.PMR.BIT.B5=1;//|[g25ӃW[ƂĎgp
	
	//MTU̐ݒ
	MTU1.TMDR1.BIT.MD=0x4;//샂[h̑I(ʑv[h1)
	
	//JE^NA
	MTU1.TCNT = 0;
	MTU.TSTRA.BIT.CST1 = 1;  /* JEgJn */
	
	return;	
}

// MTU2: MTCLKCD, P22, P23
static void pulse_counter_MTCLK_CD_init(void)
{
	//|[g̐ݒ
	PORT2.PMR.BIT.B2=0;//|[g22ėp|[gƂĎgp
	PORT2.PMR.BIT.B3=0;//|[g23ėp|[gƂĎgp
	
	MPC.PWPR.BIT.B0WI=0;//PFSWEWX^ւ̏݋
	MPC.PWPR.BIT.PFSWE=1;//PFSWX^ւ̏݋
	
	MPC.P22PFS.BIT.PSEL= 0x02;//|[g22MTCLKCƂĎgp
	MPC.P23PFS.BIT.PSEL= 0x02;//|[g23MTCLKDƂĎgp
	
	MPC.PWPR.BIT.PFSWE=0;//PFSWX^ւ̏݋֎~
	MPC.PWPR.BIT.B0WI=1;//PFSWEWX^ւ̏݋֎~
	
	PORT2.PMR.BIT.B2=1;//|[g22ӃW[ƂĎgp
	PORT2.PMR.BIT.B3=1;//|[g23ӃW[ƂĎgp
	
	//MTU̐ݒ
	MTU2.TMDR1.BIT.MD=0x4;//샂[h̑I(ʑv[h1)
	MTU1.TMDR3.BIT.PHCKSEL = 0x1;  //1FyMTU2́zO͈ʑNbNMTCLKCAMTCLKD 
	
	//JE^NA
	MTU2.TCNT = 0;

	MTU.TSTRA.BIT.CST2 = 1;  /* JEgJn */

	return;	
}


SINT16 pulse_counter_read_raw_count(BYTE channel)
{
	SINT16 data = 0;
	switch(channel){
	case PULSE_CHANNEL_LEFT:
		data = MTU1.TCNT;
		MTU1.TCNT = 0;
		
		break;
	case PULSE_CHANNEL_RIGHT:
		data = MTU2.TCNT;
		MTU2.TCNT = 0;
		break;
	default:
		/* DO NOTHING */
		break;
	}
	return data;
}
