//pwm.c
#include "../iodefine.h"
#include "common.h"

static void pwm_MTIOC6A_init(void);
static void pwm_MTIOC7A_init(void);
static void pwm_MTIOC3A_init(void);
static void pwm_MTIOC4A_init(void);
static void pwm_MTIOC8B_init(void);


void pwm_init(void){
	//W[Xgbv̉
	SYSTEM.PRCR.WORD = 0xA502;			// MSTPCRAWX^veNg̉
	SYSTEM.MSTPCRA.BIT.MSTPA9 = 0;		// MTU3̃XgbvԂ̉
	SYSTEM.PRCR.WORD = 0xA500;			// MSTPCRAWX^veNg̐ݒ
	
	pwm_MTIOC6A_init();	//MTU6: PWM_MOT_L1	MTIOC6A_PE7
	pwm_MTIOC7A_init();	//MTU7: PWM_MOT_L2	MTIOC7A_PA2
	pwm_MTIOC3A_init();	//MTU3: PWM_MOT_R1	MTIOC3A_P14
	pwm_MTIOC4A_init();	//MTU4: PWM_MOT_R2	MTIOC3A_PB3 
	pwm_MTIOC8B_init();	//MTU8: BUZZER0		MTIOC8B_PA2
			
}


//MTU6: PWM_MOT_L1	MTIOC6A_PE7
static void pwm_MTIOC6A_init(void){
	//|[g̐ݒ
	PORTE.PMR.BIT.B7=0;//|[gE7ėp|[gƂĎgp
	
	MPC.PWPR.BIT.B0WI=0;//PFSWEWX^ւ̏݋
	MPC.PWPR.BIT.PFSWE=1;//PFSWX^ւ̏݋
	
	MPC.PE7PFS.BIT.PSEL= 0x08;//|[gE6MTIOC6AƂĎgp
	
	MPC.PWPR.BIT.PFSWE=0;//PFSWX^ւ̏݋֎~
	MPC.PWPR.BIT.B0WI=1;//PFSWEWX^ւ̏݋֎~
	
	PORTE.PMR.BIT.B7=1;//|[gE7ӃW[ƂĎgp
	
	//MTU̐ݒ
	MTU6.TCR.BIT.CCLR=0x1;//TGRÃRyA}b`ŃJEgNA
	MTU6.TCR.BIT.CKEG=0x0;//オGbWŃJEg
	
	MTU6.TCR.BIT.TPSC=0x00;  //NbNFPCLKA/1ŃJEg

	
	MTU6.TMDR1.BIT.MD=0x2;//샂[h̑I(PWM[h1)

	//MTU6.TIORH.BIT.IOA=0x06;//g`x̑I(HighATGRAƃRyA}b`HIGH)
	//MTU6.TIORH.BIT.IOB=0x05;//g`x̑I(HighATGRBƃRyA}b`Low)
	
	MTU6.TIORH.BIT.IOA=0x01;//g`x̑I(HighATGRAƃRyA}b`HIGH)
	MTU6.TIORH.BIT.IOB=0x01;//g`x̑I(HighATGRBƃRyA}b`Low)
	return;
}


//MTU7: PWM_MOT_L2	MTIOC7A_PA2
static void pwm_MTIOC7A_init(void){
	//|[g̐ݒ
	PORTA.PMR.BIT.B2=0;//|[gA2ėp|[gƂĎgp
	//PORTA.PODR.BIT.B2 = 1;
	MPC.PWPR.BIT.B0WI=0;//PFSWEWX^ւ̏݋
	MPC.PWPR.BIT.PFSWE=1;//PFSWX^ւ̏݋
	
	MPC.PA2PFS.BIT.PSEL= 0x08;//|[gA2MTIOC7AƂĎgp 001000b
	
	MPC.PWPR.BIT.PFSWE=0;//PFSWX^ւ̏݋֎~
	MPC.PWPR.BIT.B0WI=1;//PFSWEWX^ւ̏݋֎~
	
	PORTA.PMR.BIT.B2=1;//|[gA2ӃW[ƂĎgp
	
	MTU.TOERB.BIT.OE7A = 1; //}X^rbguMTUo͋vɐݒ
	
	//MTU̐ݒ
	MTU7.TCR.BIT.CCLR=0x1;//TGRÃRyA}b`ŃJEgNA
	MTU7.TCR.BIT.CKEG=0x0;//オGbWŃJEg
	
	MTU7.TCR.BIT.TPSC=0x00;  //NbNFPCLKA/1ŃJEg

	
	MTU7.TMDR1.BIT.MD=0x2;//샂[h̑I(PWM[h1)

	MTU7.TIORH.BIT.IOA=0x01;//g`x̑I(HighATGRAƃRyA}b`HIGH)
	MTU7.TIORH.BIT.IOB=0x01;//g`x̑I(HighATGRBƃRyA}b`Low)
	return;
}


//MTU3: PWM_MOT_R1	MTIOC3A_P14
static void pwm_MTIOC3A_init(void){
	//|[g̐ݒ
	PORT1.PMR.BIT.B4=0;//|[g14ėp|[gƂĎgp
	
	MPC.PWPR.BIT.B0WI=0;//PFSWEWX^ւ̏݋
	MPC.PWPR.BIT.PFSWE=1;//PFSWX^ւ̏݋
	
	MPC.P14PFS.BIT.PSEL= 0x01;//|[g14MTIOC3AƂĎgp
	
	MPC.PWPR.BIT.PFSWE=0;//PFSWX^ւ̏݋֎~
	MPC.PWPR.BIT.B0WI=1;//PFSWEWX^ւ̏݋֎~
	
	PORT1.PMR.BIT.B4=1;//|[g14ӃW[ƂĎgp
	
	//MTU̐ݒ
	MTU3.TCR.BIT.CCLR=0x1;//TGRÃRyA}b`ŃJEgNA
	MTU3.TCR.BIT.CKEG=0x0;//オGbWŃJEg
	
	MTU3.TCR.BIT.TPSC=0x00;  //NbNFPCLKA/1ŃJEg

	MTU3.TMDR1.BIT.MD=0x2;//샂[h̑I(PWM[h1)
	
	MTU3.TIORH.BIT.IOA=0x01;//g`x̑I(HighATGRAƃRyA}b`HIGH)
	MTU3.TIORH.BIT.IOB=0x01;//g`x̑I(HighATGRBƃRyA}b`Low)
	return;
}



//MTU4: PWM_MOT_R2	MTIOC4A_PB3
static void pwm_MTIOC4A_init(void){
	//|[g̐ݒ
	PORTB.PMR.BIT.B3=0;//|[gB3ėp|[gƂĎgp
	
	MPC.PWPR.BIT.B0WI=0;//PFSWEWX^ւ̏݋
	MPC.PWPR.BIT.PFSWE=1;//PFSWX^ւ̏݋
	
	MPC.PB3PFS.BIT.PSEL= 0x02;//|[gB3MTIOC4AƂĎgp
	
	MPC.PWPR.BIT.PFSWE=0;//PFSWX^ւ̏݋֎~
	MPC.PWPR.BIT.B0WI=1;//PFSWEWX^ւ̏݋֎~
	
	PORTB.PMR.BIT.B3=1;//|[gB3ӃW[ƂĎgp
	
	//MTIOC4ÁAȂƏo͂łȂ
	MTU.TOERA.BIT.OE4A = 1; //}X^rbguMTUo͋vɐݒ
	
	//MTU̐ݒ
	MTU4.TCR.BIT.CCLR=0x1;//TGRÃRyA}b`ŃJEgNA
	MTU4.TCR.BIT.CKEG=0x0;//オGbWŃJEg
	
	MTU4.TCR.BIT.TPSC=0x00;  //NbNFPCLKA/1ŃJEg

	
	MTU4.TMDR1.BIT.MD=0x2;//샂[h̑I(PWM[h1)
	
	MTU4.TIORH.BIT.IOA=0x01;//g`x̑I(HighATGRAƃRyA}b`HIGH)
	MTU4.TIORH.BIT.IOB=0x01;//g`x̑I(HighATGRBƃRyA}b`Low)
	return;
}


//MTU0: BUZZER0	MTIOC8B_PD4
static void pwm_MTIOC8B_init(void){
	//|[g̐ݒ
	PORTD.PMR.BIT.B4=0;//|[gB3ėp|[gƂĎgp
	
	MPC.PWPR.BIT.B0WI=0;//PFSWEWX^ւ̏݋
	MPC.PWPR.BIT.PFSWE=1;//PFSWX^ւ̏݋
	
	MPC.PD4PFS.BIT.PSEL= 0x08;//|[gB3MTIOC8BƂĎgp
	
	MPC.PWPR.BIT.PFSWE=0;//PFSWX^ւ̏݋֎~
	MPC.PWPR.BIT.B0WI=1;//PFSWEWX^ւ̏݋֎~
	
	PORTD.PMR.BIT.B4=1;//|[gD4ӃW[ƂĎgp
	
	//MTU̐ݒ
	MTU8.TCR.BIT.CCLR=0x1;//TGRÃRyA}b`ŃJEgNA
	MTU8.TCR.BIT.CKEG=0x0;//オGbWŃJEg
	
	MTU8.TCR.BIT.TPSC=0x00;  //NbNFPCLKA/1ŃJEg

	
	MTU8.TMDR1.BIT.MD=0x0;//샂[h̑I(PWM[h1)
	
	MTU8.TIORH.BIT.IOA=0x03;//g`x̑I(LowATGRAƃRyA}b`Low)
	MTU8.TIORH.BIT.IOB=0x03;//g`x̑I(LowATGRBƃRyA}b`Higi)
	
	return;
}



void pwm_set_cycle_duty_MTIOC6A(unsigned int CMTA,unsigned int CMTB){
	MTU.TSTRB.BIT.CST6=0;	//JEg~
	MTU6.TCNT = 0;	 //^C}JE^NA
	

	MTU6.TIORH.BIT.IOA=0x06;//g`x̑I(HighATGRAƃRyA}b`HIGH)
	MTU6.TIORH.BIT.IOB=0x05;//g`x̑I(HighATGRBƃRyA}b`Low)	

		
	MTU6.TGRA=CMTA;  //TGRÃRyA}b`ݒ()
	MTU6.TGRB=CMTB;  //TGRB̃RyA}b`ݒ(DUTY)
	//JEgJn
	MTU.TSTRB.BIT.CST6=1;

	return;
}


void pwm_set_off_MTIOC6A(void){
	MTU.TSTRB.BIT.CST6=0;	//JEg~
	MTU6.TCNT = 0;	 //^C}JE^NA
	

	MTU6.TIORH.BIT.IOA=0x01;//g`x̑I(LowATGRAƃRyA}b`Low)
	MTU6.TIORH.BIT.IOB=0x01;//g`x̑I(LowATGRBƃRyA}b`Low)			

	
	MTU6.TGRA=0;  //TGRÃRyA}b`ݒ()
	MTU6.TGRB=0;  //TGRB̃RyA}b`ݒ(DUTY)
	//JEgJn
	MTU.TSTRB.BIT.CST6=1;	
	
}


void pwm_set_cycle_duty_MTIOC7A(unsigned int CMTA,unsigned int CMTB){


	MTU.TSTRB.BIT.CST7=0;	//JEg~
	MTU7.TCNT = 0;	 //^C}JE^NA

	MTU7.TIORH.BIT.IOA=0x06;//g`x̑I(HighATGRAƃRyA}b`HIGH)
	MTU7.TIORH.BIT.IOB=0x05;//g`x̑I(HighATGRBƃRyA}b`Low)	

	MTU7.TGRA=CMTA;  //TGRÃRyA}b`ݒ()
	MTU7.TGRB=CMTB;  //TGRB̃RyA}b`ݒ(DUTY)

	//JEgJn
	MTU.TSTRB.BIT.CST7=1;

	return;
}


void pwm_set_off_MTIOC7A(void){
	MTU.TSTRB.BIT.CST7=0;	//JEg~
	MTU7.TCNT = 0;	 //^C}JE^NA
	

	MTU7.TIORH.BIT.IOA=0x01;//g`x̑I(LowATGRAƃRyA}b`Low)
	MTU7.TIORH.BIT.IOB=0x01;//g`x̑I(LowATGRBƃRyA}b`Low)			

	
	MTU7.TGRA=0;  //TGRÃRyA}b`ݒ()
	MTU7.TGRB=0;  //TGRB̃RyA}b`ݒ(DUTY)
	//JEgJn
	MTU.TSTRB.BIT.CST7=1;	
	
}


void pwm_set_cycle_duty_MTIOC3A(unsigned int CMTA,unsigned int CMTB){

	MTU.TSTRA.BIT.CST3=0;	//JEg~

	MTU3.TCNT = 0;	 //^C}JE^NA
	

	MTU3.TIORH.BIT.IOA=0x06;//g`x̑I(HighATGRAƃRyA}b`HIGH)
	MTU3.TIORH.BIT.IOB=0x05;//g`x̑I(HighATGRBƃRyA}b`Low)	

	
	MTU3.TGRA=CMTA;  //TGRÃRyA}b`ݒ()
	MTU3.TGRB=CMTB;  //TGRB̃RyA}b`ݒ(DUTY)
	//JEgJn
	MTU.TSTRA.BIT.CST3=1;

	return;
}


void pwm_set_off_MTIOC3A(void){
	MTU.TSTRA.BIT.CST3=0;	//JEg~

	MTU3.TCNT = 0;	 //^C}JE^NA
	

	MTU3.TIORH.BIT.IOA=0x01;//g`x̑I(LowATGRAƃRyA}b`Low)
	MTU3.TIORH.BIT.IOB=0x01;//g`x̑I(LowATGRBƃRyA}b`Low)			

	
	MTU3.TGRA=0;  //TGRÃRyA}b`ݒ()
	MTU3.TGRB=0;  //TGRB̃RyA}b`ݒ(DUTY)
	//JEgJn
	MTU.TSTRA.BIT.CST3=1;	
	
}


void pwm_set_cycle_duty_MTIOC4A(unsigned int CMTA,unsigned int CMTB){

	MTU.TSTRA.BIT.CST4=0;	//JEg~
//
	MTU4.TCNT = 0;	 //^C}JE^NA
	

	MTU4.TIORH.BIT.IOA=0x06;//g`x̑I(HighATGRAƃRyA}b`HIGH)
	MTU4.TIORH.BIT.IOB=0x05;//g`x̑I(HighATGRBƃRyA}b`Low)	

	
	MTU4.TGRA=CMTA;  //TGRÃRyA}b`ݒ()
	MTU4.TGRB=CMTB;  //TGRB̃RyA}b`ݒ(DUTY)
	//JEgJn
	MTU.TSTRA.BIT.CST4=1;

	return;
}



void pwm_set_off_MTIOC4A(void)
{
	MTU.TSTRA.BIT.CST4=0;	//JEg~
	MTU4.TCNT = 0;	 //^C}JE^NA
	

	MTU4.TIORH.BIT.IOA=0x01;//g`x̑I(LowATGRAƃRyA}b`Low)
	MTU4.TIORH.BIT.IOB=0x01;//g`x̑I(LowATGRBƃRyA}b`Low)			

	
	MTU4.TGRA=0;  //TGRÃRyA}b`ݒ()
	MTU4.TGRB=0;  //TGRB̃RyA}b`ݒ(DUTY)
	//JEgJn
	MTU.TSTRA.BIT.CST4=1;
	
}


void pwm_set_cycle_duty_MTIOC8B(unsigned int CMTA){

	MTU.TSTRA.BIT.CST8=0;	//JEg~

	MTU8.TCNT = 0;	 //^C}JE^NA
	
	
	MTU8.TIORH.BIT.IOA=0x03;//g`x̑I(LowATGRAƃRyA}b`ŃgO)
	MTU8.TIORH.BIT.IOB=0x03;//g`x̑I(LowATGRBƃRyA}b`ŃgO)
	
	
	MTU8.TGRA=CMTA;  //TGRÃRyA}b`ݒ()
	MTU8.TGRB=CMTA/2;  //TGRÃRyA}b`ݒ()

	//JEgJn
	MTU.TSTRA.BIT.CST8=1;

	return;
}


void pwm_off_MTIOC8B(void){

	MTU.TSTRA.BIT.CST8=0;	//JEg~

	MTU8.TCNT = 0;	 //^C}JE^NA
	MTU8.TIORH.BIT.IOA=0x01;//g`x̑I(LowATGRAƃRyA}b`ŃgO)
	MTU8.TIORH.BIT.IOB=0x01;//g`x̑I(LowATGRBƃRyA}b`ŃgO)
	
	MTU8.TGRA=1111;  //TGRÃRyA}b`ݒ()
	MTU8.TGRB=1111;  //TGRÃRyA}b`ݒ()

	//JEgJn
	MTU.TSTRA.BIT.CST8=1;

	return;
}


void init_mtu2(void){
	//W[Xgbv̉
	SYSTEM.PRCR.WORD = 0xA502;			// MSTPCRAWX^veNg̉
	SYSTEM.MSTPCRA.BIT.MSTPA9 = 0;		// MTU3̃XgbvԂ̉
	SYSTEM.PRCR.WORD = 0xA500;			// MSTPCRAWX^veNg̐ݒ

	
	//|[g̐ݒ
	PORT2.PMR.BIT.B6=0;//|[g26ėp|[gƂĎgp
	
	MPC.PWPR.BIT.B0WI=0;//PFSWEWX^ւ̏݋
	MPC.PWPR.BIT.PFSWE=1;//PFSWX^ւ̏݋
	
	MPC.P26PFS.BIT.PSEL=0x01;//|[g26MTIOC2BƂĎgp
	
	MPC.PWPR.BIT.PFSWE=0;//PFSWX^ւ̏݋֎~
	MPC.PWPR.BIT.B0WI=1;//PFSWEWX^ւ̏݋֎~
	
	PORT2.PMR.BIT.B6=1;//|[g27Ӓ[qƂĎgp
	
	//MTU̐ݒ
	MTU2.TCR.BIT.CCLR=0x1;//TGRÃRyA}b`ŃJEgNA
	MTU2.TCR.BIT.CKEG=0x0;//オGbWŃJEg
	
	MTU2.TCR.BIT.TPSC=0x01;//NbNFPCLKA/4ŃJEg

	
	MTU2.TMDR1.BIT.MD=0x2;//샂[h̑I(PWM[h1)
	
	MTU2.TIOR.BIT.IOA=0x02;//g`x̑I(TGRA,LowARyA}b`High)
	MTU2.TIOR.BIT.IOB=0x01;//g`x̑I(TGRB,LowARyA}b`Low)
		
}

void pwm_out_mtu2(int CMTA,int CMTB){
	MTU2.TGRA=CMTA-1;//TGRÃRyA}b`ݒ()
	MTU2.TGRB=CMTB-1;//TGRB̃RyA}b`ݒ(DUTY)
	//JEgJn
	MTU.TSTRA.BIT.CST2=1;
}

void pwm_stop_mtu2(void){
	//JEg~
	MTU.TSTRA.BIT.CST2=0;
}

void init_mtu0(void){
	//W[Xgbv̉
	SYSTEM.PRCR.WORD = 0xA502;			// MSTPCRAWX^veNg̉
	SYSTEM.MSTPCRA.BIT.MSTPA9 = 0;			// MTU3̃XgbvԂ̉
	SYSTEM.PRCR.WORD = 0xA500;			// MSTPCRAWX^veNg̐ݒ

	
	//|[g̐ݒ
	PORT3.PMR.BIT.B4=0;//|[g34ėp|[gƂĎgp
	
	MPC.PWPR.BIT.B0WI=0;//PFSWEWX^ւ̏݋
	MPC.PWPR.BIT.PFSWE=1;//PFSWX^ւ̏݋
	
	MPC.P34PFS.BIT.PSEL=0x01;//|[g34MTIOC0AƂĎgp
	
	MPC.PWPR.BIT.PFSWE=0;//PFSWX^ւ̏݋֎~
	MPC.PWPR.BIT.B0WI=1;//PFSWEWX^ւ̏݋֎~
	
	PORT3.PMR.BIT.B4=1;//|[g34Ӓ[qƂĎgp
	
	//MTU̐ݒ
	MTU0.TCR.BIT.CCLR=0x1;//TGRÃRyA}b`ŃJEgNA
	MTU0.TCR.BIT.CKEG=0x0;//オGbWŃJEg
	
	MTU0.TCR2.BIT.TPSC2=0x04;//NbNFPCLKA/256ŃJEg

	
	MTU0.TMDR1.BIT.MD=0x2;//샂[h̑I(PWM[h1)
	
	MTU0.TIORH.BIT.IOA=0x02;//g`x̑I(TGRA,LowARyA}b`High)
	MTU0.TIORH.BIT.IOB=0x01;//g`x̑I(TGRB,LowARyA}b`Low)
		
}


void pwm_out_mtu0(int CMTA,int CMTB){
	MTU0.TGRA=CMTA-1;//TGRÃRyA}b`ݒ()
	MTU0.TGRB=CMTB-1;//TGRB̃RyA}b`ݒ(DUTY)
	//JEgJn
	MTU.TSTRA.BIT.CST0=1;
}

void pwm_stop_mtu0(void){
	//JEg~
	MTU.TSTRA.BIT.CST0=0;
}