//serial.c

#include <stdio.h>

#include "../iodefine.h"
#include "common.h"
#include "serial.h"
#include "..\main\ring_buffer.h"

static void serial_interrupt_init(void);


//SCI0̏
void serial_init(void)
{   	
	/* SCI0̓ */
	SYSTEM.PRCR.WORD = 0xA502;	//d͒ጸ@\֘AWX^ւ̏݋
	MSTP(SCI0) = 0;			//SCI0Lɂ
	SYSTEM.PRCR.WORD = 0xA500;	//d͒ጸ@\֘AWX^ւ̏݋֎~

	SCI0.SCR.BYTE = 0x00; 		// Stop SCI(TE=RE=0),use internal P clock
	
	/* [1]IO|[g@\ݒ */
	PORT2.PMR.BIT.B0 = 1;			//P20ӃW[ɐݒ
	PORT2.PMR.BIT.B1 = 1;			//P21ӃW[ɐݒ
						//PmnPFSWX^ɑ΂鏑݂
	MPC.PWPR.BIT.B0WI = 0;			//PFSWErbgɑ΂鏑݂
	MPC.PWPR.BIT.PFSWE = 1;			//PmnPFSWX^ɑ΂鏑݂
	MPC.P20PFS.BIT.PSEL = 0x0A;		//P20TXD0pɐݒ
	MPC.P21PFS.BIT.PSEL = 0x0A;		//P21RXD0pɐݒ
	MPC.PWPR.BYTE = 0x80;			//PmnPFSWX^ɑ΂鏑݂֎~
		
	/* [4]M/MtH[}bgݒ */
	SCI0.SMR.BYTE = 0x00; 		// Asynchronous,8data,none parity,1stop,n=0:BRRclock:P
	
	/* [5]rbg[g̐ݒ */
	SCI0.BRR =  15;     		// 20000000/(64*0.5*38400) - 1 = 15.27604166c

	/* [7]TXD0,RDX0gp\ɐݒ */
	SCI0.SCR.BYTE = 0x30;		// Rx and Tx are enable.
	
	serial_interrupt_init();
}

//VA(UART)֘ÃG[`FbNĕAB
void serial_check_recover_error_state(void)
{
	//UART0̎MI[o[G[
	if(SCI0.SSR.BIT.ORER != 0){
		SCI0.SSR.BIT.ORER = 0;
	}
	
	//UART0̎MpeBG[
	if(SCI0.SSR.BIT.PER != 0){
		SCI0.SSR.BIT.PER = 0;
	}

	//UART0̎Mt[~OG[
	if(SCI0.SSR.BIT.FER != 0){
		SCI0.SSR.BIT.FER = 0;
	}
	
	//UART6̎MI[o[G[
	if(SCI6.SSR.BIT.ORER != 0){
		SCI6.SSR.BIT.ORER = 0;
	}
	
	//UART6̎MpeBG[
	if(SCI6.SSR.BIT.PER != 0){
		SCI6.SSR.BIT.PER = 0;
	}

	//UART6̎Mt[~OG[
	if(SCI6.SSR.BIT.FER != 0){
		SCI6.SSR.BIT.FER = 0;
	}

	return;
}

//SCI0̏i荞ݎgpj
static void serial_interrupt_init(void)
{   	
	
	/* SCI0̓ */
	SYSTEM.PRCR.WORD = 0xA502;	//d͒ጸ@\֘AWX^ւ̏݋
	MSTP(SCI0) = 0;			//SCI0Lɂ
	SYSTEM.PRCR.WORD = 0xA500;	//d͒ጸ@\֘AWX^ւ̏݋֎~

	SCI0.SCR.BYTE = 0x00; 		// Stop SCI(TE=RE=0),use internal P clock
	
	/* UART0, P20(TxD0), P21(RxD0) */
	/* [1]IO|[g@\ݒ */
	PORT2.PMR.BIT.B0 = 1;			//P20ӃW[ɐݒ
	PORT2.PMR.BIT.B1 = 1;			//P21ӃW[ɐݒ
						//PmnPFSWX^ɑ΂鏑݂
	MPC.PWPR.BIT.B0WI = 0;			//PFSWErbgɑ΂鏑݂
	MPC.PWPR.BIT.PFSWE = 1;			//PmnPFSWX^ɑ΂鏑݂
	MPC.P20PFS.BIT.PSEL = 0x0A;		//P20TXD0pɐݒ
	MPC.P21PFS.BIT.PSEL = 0x0A;		//P21RXD0pɐݒ
	MPC.PWPR.BYTE = 0x80;			//PmnPFSWX^ɑ΂鏑݂֎~
		
	/* [4]M/MtH[}bgݒ */
	SCI0.SMR.BYTE = 0x00; 		// Asynchronous,8data,none parity,1stop,n=0:BRRclock:P
	
	/* [5]rbg[g̐ݒ */
	SCI0.BRR = 15;     		// 20000000/(64*0.5*38400) - 1 = 15.27604166c

	/* [7]TXD0,RDX0荞݂Ŏgp\ɐݒ */
	SCI0.SCR.BYTE = 0xF0;			// Enable TXI,Enabl RXI,ERI,Rx and Tx are enable.
	
	IPR(SCI0,TXI0) = 15;		// M荞݂̗Dxݒ
	IPR(SCI0,RXI0) = 15;		// M荞݂̗Dxݒ
	IEN(SCI0,TXI0) = 0;			// M荞݂̗v֎~
	IEN(SCI0,RXI0) = 1;			// M荞݂̗v
	
	
	/* UART6, P32(TxD6), P33(RxD6) */
	/* SCI0̓ */
	SYSTEM.PRCR.WORD = 0xA502;	//d͒ጸ@\֘AWX^ւ̏݋
	MSTP(SCI6) = 0;			//SCI0Lɂ
	SYSTEM.PRCR.WORD = 0xA500;	//d͒ጸ@\֘AWX^ւ̏݋֎~

	SCI6.SCR.BYTE = 0x00; 		// Stop SCI(TE=RE=0),use internal P clock
	
	
	PORT3.PMR.BIT.B2 = 1;			//P32ӃW[ɐݒ
	PORT3.PMR.BIT.B3 = 1;			//P33ӃW[ɐݒ
						//PmnPFSWX^ɑ΂鏑݂
	MPC.PWPR.BIT.B0WI = 0;			//PFSWErbgɑ΂鏑݂
	MPC.PWPR.BIT.PFSWE = 1;			//PmnPFSWX^ɑ΂鏑݂
	MPC.P32PFS.BIT.PSEL = 0x0A;		//P32TXD0pɐݒ
	MPC.P33PFS.BIT.PSEL = 0x0A;		//P33RXD0pɐݒ
	MPC.PWPR.BYTE = 0x80;			//PmnPFSWX^ɑ΂鏑݂֎~
		
	/* [4]M/MtH[}bgݒ */
	SCI6.SMR.BYTE = 0x00; 		// Asynchronous,8data,none parity,1stop,n=0:BRRclock:P
	
	/* [5]rbg[g̐ݒ */
	SCI6.BRR = 15;     		// 20000000/(64*0.5*38400) - 1 = 15.27604166c

	/* [7]TXD0,RDX0荞݂Ŏgp\ɐݒ */
	SCI6.SCR.BYTE = 0xF0;			// Enable TXI,Enabl RXI,ERI,Rx and Tx are enable.
	
	IPR(SCI6,TXI6) = 15;		// M荞݂̗Dxݒ
	IPR(SCI6,RXI6) = 15;		// M荞݂̗Dxݒ
	IEN(SCI6,TXI6) = 0;			// M荞݂̗v֎~
	IEN(SCI6,RXI6) = 1;			// M荞݂̗v

	
	return;
}



//^[~i1M
void putchar_to_terminal(BYTE data)
{ //

#ifdef COMM_OUT_RS232C
	//while(SCI0.SSR.BIT.TDRE == 0);	// TDRɏ݉\ł
	//SCI0.TDR = data;              	// }CRPC
#endif

#ifdef COMM_OUT_ZIGBEE
	while(SCI6.SSR.BIT.TDRE == 0);	// TDRɏ݉\ł
	SCI6.TDR = data;              	// }CRPC
#endif
}

//^[~i1M
char getchar_from_terminal(void)
{
	char moji;
	
	while(SCI0.SSR.BIT.RDRF == 0);	//RDRɃf[^
	moji = SCI0.RDR;		//PC}CR
	
	return moji;
}

/* Mobt@̖Mf[^𑗐MJn */
void serial_start_tx(void)
{
#ifdef COMM_OUT_RS232C
	if(ringbuffer_tx_get_unread_count() > 0){
		SCI0.SSR.BIT.TDRE = 0;
		IEN( SCI0,TXI0 ) = 1;	//M荞݉
	} else {
		/*do nothing*/	
	}
#endif

#ifdef COMM_OUT_ZIGBEE
	if(ringbuffer_tx_get_unread_count() > 0){
		SCI6.SSR.BIT.TDRE = 0;
		IEN( SCI6,TXI6 ) = 1;	//M荞݉
	} else {
		/*do nothing*/	
	}
#endif
	return;
}

//M荞݁Fintprg.cExcep_SCI0_RXI0ɒǉ
void excep_sci0_rxi0(void)
{
	BYTE data;
	data = SCI0.RDR;

	ringbuffer_rx_write_byte(data);
	//while(SCI0.SSR.BIT.TDRE == 0);	// TDRɏ݉\ł
	//SCI0.TDR = data;              	// }CRPC
	//while(SCI6.SSR.BIT.TDRE == 0);	// TDRɏ݉\ł
	//SCI6.TDR = data;              	// }CRPC
	
	return;
}

//M荞݁Fintprg.cExcep_SCI0_TXI0ɒǉ
void excep_sci0_txi0(void)
{
	UINT16 data;
	
	if(ringbuffer_tx_get_unread_count() > 0){
		//Mf[^
		data = ringbuffer_tx_read_byte();
		if(data == END_OF_DATA){  /* Mf[^ȂȂ */
			IEN( SCI0,TXI0 ) = 0;	//M荞ݕs
		} else {
			SCI0.TDR = (BYTE)data;	/* M */
		}
	} else {
		//Mf[^Ȃ
		IEN( SCI0,TXI0 ) = 0;	//M荞ݕs
	}
//IEN( SCI0,TXI0 ) = 0;	//M荞ݕs
	return;
}


void excep_sci6_txi6(void)
{
	UINT16 data;
	
	if(ringbuffer_tx_get_unread_count() > 0){
		//Mf[^
		data = ringbuffer_tx_read_byte();
		if(data == END_OF_DATA){  /* Mf[^ȂȂ */
			IEN( SCI6,TXI6 ) = 0;	//M荞ݕs
		} else {
			SCI6.TDR = (BYTE)data;	/* M */
		}
	} else {
		//Mf[^Ȃ
		IEN( SCI6,TXI6 ) = 0;	//M荞ݕs
	}	
}

void excep_sci6_rxi6(void)
{
	BYTE data;
	data = SCI6.RDR;

	ringbuffer_rx_write_byte(data);
	//while(SCI0.SSR.BIT.TDRE == 0);	// TDRɏ݉\ł
	//SCI0.TDR = data;              	// }CRPC
	
//	while(SCI6.SSR.BIT.TDRE == 0);	// TDRɏ݉\ł
//	SCI6.TDR = data;              	// }CRPC
	return;
}



