//spi.c
#include "machine.h"
#include "../iodefine.h"
#include "common.h"
#include "spi.h"
#include "timer.h"

static BYTE spi_read_byte(void);
static void spi_write_byte(BYTE data);

void spi_init(void)
{
	//W[Xgbv̉
	SYSTEM.PRCR.WORD = 0xA502;			// MSTPCRBWX^veNg̉
	SYSTEM.MSTPCRB.BIT.MSTPB16 = 0;		// RSPI1 ̃XgbvԂ̉
	SYSTEM.PRCR.WORD = 0xA500;			// MSTPCRAWX^veNg̐ݒ
	

	//RSPI1.SPPCR.BYTE = 0x00;	//ׂăftHg
	RSPI1.SPDCR.BIT.SPBYT = 1;	//SPDRւ̓oCgANZX
	RSPI1.SPDCR.BIT.SPLW = 0;	//SPDRւ̓[hANZX
	
	RSPI1.SPDCR.BIT.SPFC = 0x01;	//P]̃t[2t[
	
	
	RSPI1.SPPCR.BIT.MOIFV = 1;	//MOSIACh̃xHIGH

	RSPI1.SPCMD0.BIT.BRDV = 0x0;
	RSPI1.SPCMD0.BIT.CPOL=	0x1;	//AChRSPCK(NbNM)HIGI
	RSPI1.SPCMD0.BIT.CPHA=	0x1;	//GbWŃf[^ωAGbWŃTv
	RSPI1.SPCMD0.BIT.SSLA=	0x0;	//iSSL0)CS0I
	RSPI1.SPCMD0.BIT.SSLKP = 0x1;	//CSM̓]܂ŕێ
	RSPI1.SPCMD0.BIT.SCKDEN = 0x1;	//RSPCKxg
	RSPI1.SPCMD0.BIT.SLNDEN = 0x1;	//RSPIX[uZNglQ[gxg

	RSPI1.SPCMD1.BIT.BRDV = 0x0;
	RSPI1.SPCMD1.BIT.CPOL=	0x1;	//AChRSPCK(NbNM)HIGI
	RSPI1.SPCMD1.BIT.CPHA=	0x1;	//GbWŃf[^ωAGbWŃTv
	RSPI1.SPCMD1.BIT.SSLA=	0x0;	//iSSL0)CS0I
	RSPI1.SPCMD1.BIT.SSLKP = 0x0;	//]ICSlQ[g
	RSPI1.SPCMD1.BIT.SCKDEN = 0x1;	//RSPCKxg
	RSPI1.SPCMD1.BIT.SLNDEN = 0x1;	//RSPIX[uZNglQ[gxg
	
	RSPI1.SPSCR.BIT.SPSLN = 0x1;	//V[PXݒ́ASPCMD0SPCMD1QƂ
	
	RSPI1.SSLP.BIT.SSL0P = 0x0;	//SSL0M̓ANeBuLOW
	
	RSPI1.SPCKD.BIT.SCKDL   = 0x1;	//RSPCKx2RSPCK

	RSPI1.SSLND.BIT.SLNDL   = 0x1;	//RSPIX[uZNglQ[gx2RSPCK
	
	RSPI1.SPBR = 0x01;	//PCLK=20MHẑƂANbN5MHz

	
	
	//|[g̐ݒ
	PORT2.PMR.BIT.B7=0;//|[g27ėp|[gƂĎgp
	PORT2.PMR.BIT.B6=0;//|[g26ėp|[gƂĎgp
	PORT3.PMR.BIT.B0=0;//|[g30ėp|[gƂĎgp
	PORT3.PMR.BIT.B1=0;//|[g31ėp|[gƂĎgp
	

	PORT2.PDR.BIT.B7=1;
	PORT2.PDR.BIT.B6=1;
	PORT3.PDR.BIT.B0=0;
	PORT3.PDR.BIT.B1=1;
	
	PORT2.PODR.BIT.B7=1;
	PORT2.PODR.BIT.B6=1;
	PORT3.PODR.BIT.B0=1;
	PORT3.PODR.BIT.B1=1;
	
	MPC.PWPR.BIT.B0WI=0;//PFSWEWX^ւ̏݋
	MPC.PWPR.BIT.PFSWE=1;//PFSWX^ւ̏݋
	
	MPC.P27PFS.BIT.PSEL= 0x0d;//001101b: |[g27 RSPCKB-A ƂĎgp
	MPC.P26PFS.BIT.PSEL= 0x0d;//001101b: |[g26 MOSIB-A ƂĎgp
	MPC.P30PFS.BIT.PSEL= 0x0d;//001101b: |[g30 MISOB-A ƂĎgp
	MPC.P31PFS.BIT.PSEL= 0x0d;//001101b: |[g31 SSLB0-A ƂĎgp
	
	MPC.PWPR.BIT.PFSWE=0;//PFSWX^ւ̏݋֎~
	MPC.PWPR.BIT.B0WI=1;//PFSWEWX^ւ̏݋֎~
	
	PORT2.PMR.BIT.B7=1;//|[g27ӃW[ƂĎgp
	PORT2.PMR.BIT.B6=1;//|[g26ӃW[ƂĎgp
	PORT3.PMR.BIT.B0=1;//|[g30ӃW[ƂĎgp
	PORT3.PMR.BIT.B1=1;//|[g31ėp|[gƂĎgp
	
	
	PORT2.DSCR2.BIT.B7 = 1; //C^tF[Xp쓮o
	//PORT2.DSCR2.BIT.B6 = 1;
	PORT3.DSCR2.BIT.B0 = 1; //C^tF[Xp쓮o
	PORT3.DSCR2.BIT.B1 = 1;
	
		
	RSPI1.SPCR.BIT.SPMS = 0x0; /* 0FSPI(4) */
	RSPI1.SPCR.BIT.MSTR = 0x1; /* 1F}X^[h */
	
	RSPI1.SSLP.BIT.SSL0P = 0x0;	/* 0FSSL0M̓ANeBuLow */

	

	RSPI1.SPCR.BIT.SPE =  0x1; /* 1FRSPI@\͗L */

		
	return;
}


static BYTE spi_read_byte(void)
{
	BYTE data;
	while(RSPI1.SPSR.BIT.SPRF == 0);
	data = RSPI1.SPDR.BYTE.HH;
	
	return(data);
	
}

static void spi_write_byte(BYTE data)
{
	while(RSPI1.SPSR.BIT.SPTEF == 0);
	RSPI1.SPDR.BYTE.HH = data;
	return;	
}

//SPIfoCXɃR}hZbgẲ𓾂
//1̓ǂݎɁA5us炢
BYTE spi_read_data(BYTE address)
{
	volatile BYTE read_data;
	
	spi_write_byte(address);	//AhX𑗂
	spi_write_byte(0xFF);		//foCX牞ԂĂԂf[^͏o͂
	
	read_data = spi_read_byte();	//_~[[hAMɓǂݍ܂ꂽf[^荞
	read_data = spi_read_byte();	//foCX̉f[^荞
	
	return(read_data);
	
}


void spi_write_data(BYTE address, BYTE command)
{
	volatile BYTE read_data;
	
	spi_write_byte(address);	//AhX𑗂
	spi_write_byte(0xFF);		//R}h𑗂
	
	read_data = spi_read_byte();	//_~[[hAMɓǂݍ܂ꂽf[^荞
	read_data = spi_read_byte();	
	
	return;
	

}
