
#include "buzzer_sound.h"
#include "common.h"

static SINT16 buzzer_sustain_count;
static BOOL is_buzzer_state_changed;

#define BUZZER_SUSTAIN_TERM_SHORT (3)

#define BUZZER_SUSTAIN_TERM_MIDDLE (20)
#define BUZZER_SUSTAIN_TERM_LONG (100)

typedef enum {
	BUZZER_H,
	BUZZER_L,
	BUZZER_OFF,
	NUMBER_OF_BUZZER_STATE
	
} e_buzzer_state;

e_buzzer_state buzzer_state;

void buzzer_init(void)
{
	is_buzzer_state_changed = TRUE;
	buzzer_state = BUZZER_OFF;
	buzzer_sustain_count = 0;
}

void buzzer_control(void)
{
	
	if(buzzer_sustain_count <= 0){
		buzzer_off();
	} else {
		buzzer_sustain_count --;
		
		
	}
	
	if( is_buzzer_state_changed == TRUE ){	
		switch(buzzer_state){
		case BUZZER_H:
			pwm_set_cycle_duty_MTIOC8B(11364/2);
			break;
		case BUZZER_L:
			pwm_set_cycle_duty_MTIOC8B(11364);	
			break;
		case BUZZER_OFF:
			pwm_off_MTIOC8B();
			break;
		default:
			/* do nothing */
			break;
			
		}
		is_buzzer_state_changed = FALSE;

	}
		
	return;
	
}

void buzzer_on_short_L(void)
{
	
	if(buzzer_sustain_count == 0){
		is_buzzer_state_changed = TRUE;
	}
	buzzer_sustain_count = BUZZER_SUSTAIN_TERM_SHORT;
	buzzer_state = BUZZER_L;
	
	//buzzer_on_L();
	
	return;
}


void buzzer_on_short_H(void)
{
	
	if(buzzer_sustain_count == 0){
		is_buzzer_state_changed = TRUE;
	}
	buzzer_sustain_count = BUZZER_SUSTAIN_TERM_SHORT;
	buzzer_state = BUZZER_H;
	
	
	return;
}

void buzzer_on_middle_L(void)
{
	if(buzzer_sustain_count == 0){
		is_buzzer_state_changed = TRUE;
	}
	buzzer_sustain_count = BUZZER_SUSTAIN_TERM_MIDDLE;

	buzzer_state = BUZZER_L;
}

void buzzer_on_middle_H(void)
{
	if(buzzer_sustain_count == 0){
		is_buzzer_state_changed = TRUE;
	}
	buzzer_sustain_count = BUZZER_SUSTAIN_TERM_MIDDLE;

	buzzer_state = BUZZER_H;
	
	return;
}

void buzzer_on_long_L(void)
{
	if(buzzer_sustain_count == 0){
		is_buzzer_state_changed = TRUE;
	}
	buzzer_sustain_count = BUZZER_SUSTAIN_TERM_LONG;

	buzzer_state = BUZZER_L;
}

void buzzer_on_long_H(void)
{
	if(buzzer_sustain_count == 0){
		is_buzzer_state_changed = TRUE;
	}
	buzzer_sustain_count = BUZZER_SUSTAIN_TERM_LONG;

	buzzer_state = BUZZER_H;
	
	return;
}




void buzzer_on_H(void)
{
	buzzer_state = BUZZER_H;
	is_buzzer_state_changed = TRUE;
	return;
}

void buzzer_on_L(void)
{
	buzzer_state = BUZZER_L;
	is_buzzer_state_changed = TRUE;

	return;
}

void buzzer_off(void)
{
	buzzer_state = BUZZER_OFF;
	is_buzzer_state_changed = TRUE;

	return;
}