
#include "../iodefine.h"
#include <stdio.h>
#include <string.h>
#include "common.h"
#include "ring_buffer.h"
#include "read_sw.h"
#include "adc.h"
#include "pulse_counter.h"
#include "motor.h"
#include "distance_sensor.h"
#include "gyro_sensor.h"
#include "remote_control.h"
#include "reflect_sensor.h"
#include "console.h"

char console_buf_rec[CONSOLE_BUF_SIZE];
char console_buf_send[CONSOLE_BUF_SIZE];

char remote_command_buf[REMOTE_COMMAND_BUF_SIZE];

BOOL new_remote_command;

void console_init(void)
{
	
	
}

/* V[gR}h͂邩H */
BOOL console_is_new_remote_command(void)
{
	return new_remote_command;	
}

/* [gR}h̕擪AhhXԂ */
char *console_get_remote_comm_str(void)
{
	new_remote_command = FALSE;  /* VR}hԂ̂ŃtOOFFɂB */
	return remote_command_buf;	
	
}

void console_process_input(void)
{
	if(ringbuffer_rx_is_newline() == TRUE){
		ringbuffer_get_line(console_buf_rec, CONSOLE_BUF_SIZE);
		//console_set_string(console_buf_rec);
		
		/* ŏ̕"REMOTE " */
		if(strncmp(REMOTE_COMMAND_HEADER_STR, console_buf_rec, sizeof(REMOTE_COMMAND_HEADER_STR) - 1) == 0){
			new_remote_command = TRUE;
			strncpy(remote_command_buf, console_buf_rec + sizeof(REMOTE_COMMAND_HEADER_STR) - 1, REMOTE_COMMAND_BUF_SIZE);
		}
		
	}
	
}


//XCb`󋵂Ȃɂ𑗂
void console_send_status(void)
{
	t_remote_control_value remote_control_value;
	static const char *sw_status[] = {"OFF", "OFF", "PUS", " ON", "REL", "OFF", "OFF"};
	remote_control_value = remote_control_get_current_value();

	
	
	sprintf(console_buf_send, "%10u, %s, %s, %s, %s, %s, %5d, %5d, %5d, %5d, %5d, %5d, L3 %5d, L2 %5d, L1 %5d, L0 %5d, R0 %5d, R1 %5d, R2 %5d, R3 %5d, %6d, %6d, %6d, %6d, %6d, %6d%s",
		get_uptime(),
		sw_status[read_sw_state(SW_P0)],
		sw_status[read_sw_state(SW_P1)],
		sw_status[read_sw_state(SW_P2)],
		sw_status[read_sw_state(SW_T0)],
		sw_status[read_sw_state(SW_T1)],
		remote_control_value.throttle_L,//adc_get_value_as_volume(AD_VR0),
		remote_control_value.throttle_R,//adc_get_value_as_volume(AD_VR1),
		adc_get_value(AD_VBATT_WATCH),
		adc_get_value(AD_VR0),
		adc_get_value(AD_VR1),
		adc_get_value(AD_VR2),
		adc_get_value(AD_RS_OUT_L3),//reflect_sensor_get_value(RS_OUT_L3),//
		adc_get_value(AD_RS_OUT_L2),//reflect_sensor_get_value(RS_OUT_L2),//
		adc_get_value(AD_RS_OUT_L1),//reflect_sensor_get_value(RS_OUT_L1),//
		adc_get_value(AD_RS_OUT_L0),//reflect_sensor_get_value(RS_OUT_L0),//
		adc_get_value(AD_RS_OUT_R0),//reflect_sensor_get_value(RS_OUT_R0),//
		adc_get_value(AD_RS_OUT_R1),//reflect_sensor_get_value(RS_OUT_R1),//
		adc_get_value(AD_RS_OUT_R2),//reflect_sensor_get_value(RS_OUT_R2),//
		adc_get_value(AD_RS_OUT_R3),//reflect_sensor_get_value(RS_OUT_R3),//
		pulse_counter_read_raw_count(PULSE_CHANNEL_LEFT),//motor_get_speed(MOTOR_LEFT),
		pulse_counter_read_raw_count(PULSE_CHANNEL_RIGHT),//motor_get_speed(MOTOR_RIGHT),
		distance_sensor_get_distance(),
		gyro_sensor_get_raw_output_x(),
		gyro_sensor_get_raw_output_y(),
		gyro_sensor_get_raw_output_z(),
		NEW_LINE_CODE
		);
	console_set_string(console_buf_send);
	return;
}

void console_set_string(char *str)
{
	UINT16 count;
	
	for(count = 0; count < CONSOLE_BUF_SIZE; count ++){
		ringbuffer_tx_write_byte(str[count]);
		if(str[count] == '\0'){
			//ringbuffer_tx_write_byte('\n');
			break;	
		}
	}
	return;
}

void console_process_output(void)
{
	
	
}


