#include "common.h"
#include "read_sw.h"
#include "adc.h"
#include "pulse_counter.h"
#include "ring_buffer.h"
#include "serial.h"
#include "lcd.h"
#include "adc.h"
#include "motor.h"
#include "console.h"
#include "led_indicator.h"
#include "irq.h"
#include "pulse_counter.h"

#include "distance_sensor.h"
#include "remote_control.h"
#include "vehicle_control_main.h"

#include "control_main.h"


void time_slot_0(void){
	update_input_port_level();
	read_sw_state_update();
	adc_update(); //ADϊĒl𓾂

	return;
}

/*

MTU6: PWM_MOT_L1	MTIOC6A_PE7 ---> OK
MTU7: PWM_MOT_L2	MTIOC7A_PA2
MTU3: PWM_MOT_R1	MTIOC3A_P14 ---> OK
MTU4: PWM_MOT_R2	MTIOC4A_PB3
MTU8: BUZZER0		MTIOC8A_PA2  ---> OK


*/
void time_slot_1(void){
	static UINT8 motor_speed_cycle = 0;

	adc_update(); //ADϊĒl𓾂

	if(read_sw_state(SW_P0) == SW_STATE_PUSHED){

	}

	if(read_sw_state(SW_P0) == SW_STATE_PUSHED){

		
	}
	
	if(read_sw_state(SW_P1) == SW_STATE_PUSHED){

		
	}
	if(read_sw_state(SW_P1) == SW_STATE_RELEASED){
		
	}
	if(read_sw_state(SW_P2) == SW_STATE_PUSHED){

		

	}
	if(read_sw_state(SW_P2) == SW_STATE_RELEASED){


	}
	
	motor_speed_cycle ++;
	if( motor_speed_cycle > 5){
		motor_speed_cycle = 0;
		motor_update_speed();

	}
	return;
}


void time_slot_2(void){
	adc_update(); //ADϊĒl𓾂
	
	distance_sensor_update_distance();
	gyro_sensor_update_value();
	reflect_sensor_control();

	return;
}

void time_slot_3(void){
	adc_update(); //ADϊĒl𓾂
	
	console_process_input();
	
	return;
}

void time_slot_4(void){
	adc_update(); //ADϊĒl𓾂

	vehicle_control_main_slot_a();
	
	return;
}

void time_slot_5(void){
	adc_update(); //ADϊĒl𓾂
	
	vehicle_control_main_slot_b();
	
	
	return;
}

void time_slot_6(void){
	adc_update(); //ADϊĒl𓾂
	
	vehicle_control_main_slot_c();
	
	
	return;
}

void time_slot_7(void){
	adc_update(); //ADϊĒl𓾂
	
	
	return;
}

void time_slot_8(void){
	adc_update(); //ADϊĒl𓾂
	
	//led_indicator_rotate();
	//led_indicator_remote();
	//remote_control_check_command();

	led_indicator_process();
	update_output_port_level();
	buzzer_control();
	lcd_control();
	if(remote_control_is_new_data_applied() == TRUE){
		led_indicator_running_blink_start();	
	}
	
	return;
}

void time_slot_9(void){
	static UINT16 count;
	adc_update(); //ADϊĒl𓾂

	//serial_start_tx();
	count ++;
	if(count >= 20){
		console_send_status();
		count = 0;	
	}

		//putchar_to_terminal('\n');
	//M̃VAʐM̑Mn߂
	ringbuffer_send_unsent();

	adc_update_filter(); //ړσtB^Abvf[g
	
	return;
}

