#include "common.h"
#include "gpio.h"
#include "led_indicator.h"
#include "remote_control.h"

#define BLINK_SUSTAIN_INIT (2)


SINT16 indicator_running_blink_sustain;


void led_indicator_init(void)
{
	led_indicator_turn_off(LED_ST0);
	led_indicator_turn_off(LED_ST1);
	led_indicator_turn_on(LED_ST2);
	
	led_indicator_turn_off(LED_IND0);
	led_indicator_turn_off(LED_IND1);
	led_indicator_turn_off(LED_IND2);		
	led_indicator_turn_off(LED_IND3);		
	led_indicator_turn_off(LED_IND4);		
	led_indicator_turn_off(LED_IND5);		
	led_indicator_turn_off(LED_IND6);		
	led_indicator_turn_off(LED_IND7);
	
	indicator_running_blink_sustain = 0;

	return;
}

void led_indicator_process(void)
{
	if(indicator_running_blink_sustain > 0){
		indicator_running_blink_sustain --;
		led_indicator_turn_on(LED_ST1);
	} else {
		led_indicator_turn_off(LED_ST1);
		
	}
	return;
}

void led_indicator_turn_on(e_led_indicator_name led)
{
	switch(led){
	case LED_ST0:
		gpio_set_port_level(PORT_LED_ST0, PORT_LOW);
		break;
	case LED_ST1:
		gpio_set_port_level(PORT_LED_ST1, PORT_LOW);
		break;
	case LED_ST2:
		gpio_set_port_level(PORT_LED_ST2, PORT_LOW);
		break;
	case LED_IND0:
		gpio_set_port_level(PORT_LED_IND0, PORT_HIGH);
		break;
	case LED_IND1:
		gpio_set_port_level(PORT_LED_IND1, PORT_HIGH);
		break;		
	case LED_IND2:
		gpio_set_port_level(PORT_LED_IND2, PORT_HIGH);
		break;		
	case LED_IND3:
		gpio_set_port_level(PORT_LED_IND3, PORT_HIGH);
		break;		
	case LED_IND4:
		gpio_set_port_level(PORT_LED_IND4, PORT_HIGH);
		break;		
	case LED_IND5:
		gpio_set_port_level(PORT_LED_IND5, PORT_HIGH);
		break;		
	case LED_IND6:
		gpio_set_port_level(PORT_LED_IND6, PORT_HIGH);
		break;		
	case LED_IND7:
		gpio_set_port_level(PORT_LED_IND7, PORT_HIGH);
		break;
	default:
		/* do nothing */
		break;
	}
	
	return;	
}

void led_indicator_turn_off(e_led_indicator_name led)
{
	switch(led){
	case LED_ST0:
		gpio_set_port_level(PORT_LED_ST0, PORT_HIGH);
		break;
	case LED_ST1:
		gpio_set_port_level(PORT_LED_ST1, PORT_HIGH);
		break;
	case LED_ST2:
		gpio_set_port_level(PORT_LED_ST2, PORT_HIGH);
		break;
	case LED_IND0:
		gpio_set_port_level(PORT_LED_IND0, PORT_LOW);
		break;
	case LED_IND1:
		gpio_set_port_level(PORT_LED_IND1, PORT_LOW);
		break;		
	case LED_IND2:
		gpio_set_port_level(PORT_LED_IND2, PORT_LOW);
		break;		
	case LED_IND3:
		gpio_set_port_level(PORT_LED_IND3, PORT_LOW);
		break;		
	case LED_IND4:
		gpio_set_port_level(PORT_LED_IND4, PORT_LOW);
		break;		
	case LED_IND5:
		gpio_set_port_level(PORT_LED_IND5, PORT_LOW);
		break;		
	case LED_IND6:
		gpio_set_port_level(PORT_LED_IND6, PORT_LOW);
		break;		
	case LED_IND7:
		gpio_set_port_level(PORT_LED_IND7, PORT_LOW);
		break;
	default:
		/* do nothing */
		break;
	}	
	return;
}


void led_indicator_running_blink_start(void)
{
	indicator_running_blink_sustain = BLINK_SUSTAIN_INIT;
	return;	
}


void led_indicator_rotate(void)
{
	static e_output_port_name led = START_OF_OUTPUT_PORT;
	static e_output_port_name led_previous = END_OF_OUTPUT_PORT - 1;
	static UINT16 count = 0;
	
	
	
	count ++;

	if(count > 20){
		gpio_set_port_level(led_previous, PORT_HIGH);
		gpio_set_port_level(led, PORT_LOW);
		led_previous = led;
	
		led ++;
	
		if(led >= END_OF_OUTPUT_PORT){
			led = START_OF_OUTPUT_PORT;
		}
		count = 0;
	}
	
	
	
}