#include "common.h"
#include "read_sw.h"
#include "..\hardware\gpio.h"

#define SW_CHECK_COUNT  (3)

e_sw_state sw_state[END_OF_SW_NAME];
UINT8 sw_up_count[END_OF_SW_NAME];
UINT8 sw_down_count[END_OF_SW_NAME];

static void read_sw_set_raw_state(e_sw_name sw_name, e_sw_raw_state state);

void read_sw_init(void){
	e_sw_name sw;
	
	for(sw = SW_P0; sw < END_OF_SW_NAME; sw ++){
		sw_state[sw] = SW_STATE_UP;
		sw_up_count[sw] = SW_CHECK_COUNT;
		sw_down_count[sw] = 0;
	}
	
}

e_sw_state read_sw_state(e_sw_name sw){
	return(sw_state[sw]);
}


void read_sw_state_update(void){
	/* 
      SW̎ނɂāAUP/DOWÑxΉႤ̂ŁAz
	  XCb`Ԃɔf
	*/
	
	if(gpio_get_port_level(PORT_SW_P0) == GPIO_LOW){
		read_sw_set_raw_state(SW_P0, SW_RAW_STATE_UP);
	} else {
		read_sw_set_raw_state(SW_P0, SW_RAW_STATE_DOWN);
	}
	
	if(gpio_get_port_level(PORT_SW_P1) == GPIO_LOW){
		read_sw_set_raw_state(SW_P1, SW_RAW_STATE_UP);
	} else {
		read_sw_set_raw_state(SW_P1, SW_RAW_STATE_DOWN);
	}
	
	if(gpio_get_port_level(PORT_SW_P2) == GPIO_LOW){
		read_sw_set_raw_state(SW_P2, SW_RAW_STATE_UP);
	} else {
		read_sw_set_raw_state(SW_P2, SW_RAW_STATE_DOWN);
	}

	
	if(gpio_get_port_level(PORT_SW_T0) == GPIO_HIGH){
		read_sw_set_raw_state(SW_T0, SW_RAW_STATE_UP);
	} else {
		read_sw_set_raw_state(SW_T0, SW_RAW_STATE_DOWN);
	}
	
	if(gpio_get_port_level(PORT_SW_T1) == GPIO_HIGH){
		read_sw_set_raw_state(SW_T1, SW_RAW_STATE_UP);
	} else {
		read_sw_set_raw_state(SW_T1, SW_RAW_STATE_DOWN);
	}

}

/*  */
void read_sw_set_raw_state(e_sw_name sw_name, e_sw_raw_state state){
	
	if(state == SW_RAW_STATE_UP){
		sw_up_count[sw_name] ++;
		sw_down_count[sw_name] = 0;
	} else if(state == SW_RAW_STATE_DOWN){
		sw_down_count[sw_name] ++;
		sw_up_count[sw_name] = 0;
	} else {
		/* do nothing */	
	}
	
	
	/*Ƃ̓ */
	if( (sw_up_count[sw_name] > 0) && (sw_up_count[sw_name] < SW_CHECK_COUNT)){
		sw_state[sw_name] =SW_STATE_RELEASING ;
	} else if(sw_up_count[sw_name] == SW_CHECK_COUNT) {
		sw_state[sw_name] = SW_STATE_RELEASED ;
		sw_up_count[sw_name] = SW_CHECK_COUNT + 1;
	} else if(sw_up_count[sw_name] >= (SW_CHECK_COUNT + 1)) {
		sw_state[sw_name] = SW_STATE_UP ;
		sw_up_count[sw_name] = SW_CHECK_COUNT + 1;
	} else {
		/* do nothing */
	}

	/*Ƃ̓ */
	if((sw_down_count[sw_name] > 0) && (sw_down_count[sw_name] < SW_CHECK_COUNT)){
		sw_state[sw_name] = SW_STATE_PUSHING;
	} else if(sw_down_count[sw_name] == SW_CHECK_COUNT ) {
		sw_state[sw_name] = SW_STATE_PUSHED;
	} else if(sw_down_count[sw_name] >= (SW_CHECK_COUNT + 1)) {
		sw_state[sw_name] = SW_STATE_DOWN;
		sw_down_count[sw_name] = SW_CHECK_COUNT + 1;
	} else {
		/* do nothing */
		
	}
	
	return;
}