#include "common.h"
#include "console.h"
#include "led_indicator.h"
#include "remote_control.h"
#include <stdio.h>

#define REMOTE_CORRECT_CHECK (9876)  /* Mł`FbN邽߂̍t */

#define ERROR_COUNTER_MAX	(256)
#define ERROR_COUNTER_INCREMENT_ONE_CYCLE (10)
t_remote_control_value remote_data_newest;   /* RMw */
t_remote_control_value remote_data_initial = {0, 0, 0, 0, 0, 0}; /* R̎w߂r₦Ƃɍ̗pw */

SINT16 error_counter;

static BOOL new_data_applied;

static void remote_control_set_recv_data(void);


void remote_control_init(void)
{
	error_counter = ERROR_COUNTER_MAX;
	remote_data_newest = remote_data_initial;
	
	new_data_applied = FALSE;
}

/* Vremotef[^MKpꂽ */
BOOL remote_control_is_new_data_applied(void)
{
	return new_data_applied;	
}


t_remote_control_value remote_control_get_current_value(void)
{
	return remote_data_newest;
	
}

void remote_control_check_command(void)
{
	new_data_applied = FALSE;
	remote_control_set_recv_data();
	
	/* G[JE^𑝉 */
	if(error_counter <= ERROR_COUNTER_MAX){
		error_counter += ERROR_COUNTER_INCREMENT_ONE_CYCLE;
	}
	
	/* G[JE^Kl𒴂Awߒl̏l̗piԎ~߂j */
	if(error_counter >=  ERROR_COUNTER_MAX){
		//putchar_to_terminal('X');
		remote_data_newest = remote_data_initial;
		led_indicator_turn_on(LED_ST2);
	} else {
		led_indicator_turn_off(LED_ST2);
	}
	
	return;
}

/* RMf[^wߒlo */
void remote_control_set_recv_data(void)
{
	char *recv_str;
	SINT16 check;
	t_remote_control_value recv_data;
	
	/* VR}h񂪂邩 */
	if(console_is_new_remote_command() != TRUE){
		return;
	}
	
	recv_str = console_get_remote_comm_str();
	
	sscanf(recv_str, "%d, %d, %d, %d, %d, %d, %d",
		&recv_data.throttle_L,
		&recv_data.throttle_R,
		&recv_data.sw_push0,
		&recv_data.sw_push1,
		&recv_data.sw_toggle0,
		&recv_data.sw_toggle1,
		&check
	);
	
	if( check == REMOTE_CORRECT_CHECK ){
		/* Mł̂ŁAG[JE^NA */
		error_counter = 0;
		remote_data_newest = recv_data;
		new_data_applied = TRUE;
		
	}
	
	/*fobOp*/
	//putchar_to_terminal('Z');
	//putchar_to_terminal('0' + remote_data_newest.sw_toggle0);
//	for(count = 0; count < 200; count ++){
//			putchar_to_terminal(recv_str[count]);
//			if(recv_str[count] == '\0') break;
//	}
//			putchar_to_terminal('\n');
	
	return;
	
}