//ring_buffer.c

#include "common.h"
#include "ring_buffer.h"

//

#define	RING_BUFFER_TX_SIZE	255	//Oobt@̃TCY
#define	RING_BUFFER_RX_SIZE	512	//Oobt@̃TCY

static BYTE ring_buffer_tx[RING_BUFFER_TX_SIZE];
static BYTE ring_buffer_rx[RING_BUFFER_RX_SIZE];

/* Oobt@̃|C^AɃf[^ׂEǂނׂꏊ */
static UINT16 tx_read_pos;	  
static UINT16 tx_write_pos;
static UINT16 tx_unread;

static UINT16 rx_read_pos;
static UINT16 rx_write_pos;
static UINT16 rx_unread;

static UINT16 rx_new_line;

static UINT16 rx_line_unread;

static void ringbuffer_rx_newline_detected(void);


void ring_buffer_init(void)
{
	tx_read_pos  = 0;
	tx_write_pos = 0;
	tx_unread    = 0;
	rx_read_pos  = 0;
	rx_write_pos = 0;
	rx_unread    = 0;
	rx_line_unread = 0;
	
	rx_new_line = 0;
	
	return;
}

UINT16 ringbuffer_rx_get_unread_line(void)
{
	return(rx_line_unread);	
}

UINT16 ringbuffer_tx_get_unread_count(void)
{
	return(tx_unread);	
}


void ringbuffer_send_unsent(void)
{
	UINT16 unsent;
	
	unsent = ringbuffer_tx_get_unread_count();
	
	if(unsent > 0){
		serial_start_tx();
	
		//for(count = 0; count < unsent; count ++){
		//	data = ringbuffer_tx_read_byte();
		//	if(data == END_OF_DATA){
		//		break;	
		//	}
		//	putchar_to_terminal(data);
		//}
	}
}

/* 
Oobt@f[^ǂݏoB
s܂̓Oobt@̏IɒB܂ŃOobt@f[^ǂݍ
ǂݎf[^ptr_bufŎobt@ɏ
s͏܂Ȃ
f[^̏I[nullt
Oobt@f[^ǂݍ߂Ȃꍇłnullt
ptr_bufŎwobt@ɏ܂ꂽf[^̌(byte)Ԃ
*/
UINT16 ringbuffer_get_line(char *ptr_buf, UINT16 buf_size)
{
	UINT16 count;
	UINT16 data;
	
	for(count = 0; count < buf_size - 1; count ++){
		data = ringbuffer_rx_read_byte(); /* obt@ǂݏo */
		if(data == END_OF_DATA){
			/* f[^ǂݍ߂Ȃ */
			break; /* [v𔲂 */
			
		} else if(data == '\n')  {
			/*sǂݍ񂾂*/
			rx_new_line --; /* 1s荞ݍς */
			break; /* [v𔲂 */
		} else {
			
			/* ǂݍ񂾃f[^ */
			ptr_buf[count] = data;
		}
		
	}
	
	ptr_buf[count] = '\0'; /* Ōnullt */
	/* ǂݍ܂ꂽf[^̌Ԃ */
	return(count);
}

/* Vs͂ */
static void ringbuffer_rx_newline_detected(void)
{
	rx_new_line ++;	
	return;
}

BOOL ringbuffer_rx_is_newline(void)
{
	BOOL newline;
	if(rx_new_line > 0){
		newline = TRUE;
	} else {
		newline = FALSE;
	}
	return(newline);
}

void ringbuffer_tx_write_byte(BYTE data)
{
	/* ǂݍ݃f[^obt@TCYȂAobt@ɏ */
	if(tx_unread < RING_BUFFER_TX_SIZE){
		ring_buffer_tx[tx_write_pos] = data;
		
		tx_write_pos ++;
		tx_unread ++; /* ǃf[^ǉꂽ */
		
		if(tx_write_pos >= RING_BUFFER_TX_SIZE){
			tx_write_pos = 0;
		}
	} else {
		/* ߂Ȃf[^͎̂Ă */
	}
	return;
}

UINT16 ringbuffer_tx_read_byte(void)
{
	UINT16 data;
	
	
	/* ǂݍ݃f[^ */
	if(tx_unread > 0){
		data = ring_buffer_tx[tx_read_pos];
		
		tx_read_pos ++;
		tx_unread --;  /* ǃf[^菜ꂽ */
		
		/* obt@̉E[܂łǂ蒅 */
		if(tx_read_pos >= RING_BUFFER_TX_SIZE){
			tx_read_pos = 0; /* obt@̍[֐܂Ԃ */
		}
		
	} else if(tx_unread == 0){ /* ǂݍ݃f[^Ȃ */
		data = END_OF_DATA; /* f[^̏Ił邱ƂԂ */
	} else {
		
	}
	return(data);
}

void ringbuffer_rx_write_byte(BYTE data)
{
//	static BYTE previous_data = '\0';
	
	/* ǂݍ݃f[^obt@TCYȂAobt@ɏ */
	if(rx_unread < RING_BUFFER_RX_SIZE){
		/*CRLFAŗꍇA\n̂ݏ߂̏*/
//		if(previous_data == '\r'){
//			if(data == '\n'){
//				previous_data = '\0';
//				goto end_ringbuffer_rx_write_byte;
//			}
//		}

//		if(previous_data == '\n'){
//			if(data == '\r'){
//				previous_data = '\0';
//				goto end_ringbuffer_rx_write_byte;
				
//			}			
//		}
		
//		previous_data = data;

//		if(data == '\r'){
//			data = '\n'; /* \r  \n ɕϊď*/
//			rx_line_unread ++; /*1sVɓ*/
//		}		
		ring_buffer_rx[rx_write_pos] = data;
		
		rx_write_pos ++;
		rx_unread ++;
		
		if(rx_write_pos >= RING_BUFFER_RX_SIZE){
			rx_write_pos = 0;
		}
		
		/* sAVs̃JEgCNg */
		if(data == '\n'){
			ringbuffer_rx_newline_detected();	
		}
		
	} else {
		/* ߂Ȃf[^͎̂Ă */
	}
	
	if(data == '\n'){
		ringbuffer_rx_newline_detected();	
	}
	
//end_ringbuffer_rx_write_byte:
	return;
}

UINT16 ringbuffer_rx_read_byte(void)
{
	UINT16 data;
	
	
	/* ǂݍ݃f[^ */
	if(rx_unread > 0){
		data = ring_buffer_rx[rx_read_pos];
		
		rx_read_pos ++;
		rx_unread --;
		
		/* obt@̉E[܂łǂ蒅 */
		if(rx_read_pos >= RING_BUFFER_RX_SIZE){
			rx_read_pos = 0; /* obt@̍[֐܂Ԃ */
		}
		
	} else if(rx_unread == 0){ /* ǂݍ݃f[^Ȃ */
		data = END_OF_DATA; /* f[^̏Ił邱ƂԂ */
	} else {
		
	}
	return(data);
}


