/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
//#include "typedefine.h"

#include "common.h"
#include "control_main.h"
#include "../iodefine.h"
#include "gpio.h"
#include "read_sw.h"
#include "serial.h"
#include "adc.h"
#include "spi.h"
#include "distance_sensor.h"
#include <machine.h>

#define SLOT_COUNT_MAX (10)


#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

//1mso߃tO
extern BYTE timer_1ms_pass;

UINT32 uptime_1ms;


//NbNg20MHzɂ
void init_clock_frequency(void)
{
	SYSTEM.PRCR.WORD = 0xA501;	//NbNH֘AWX^ւ̏݋
	
	SYSTEM.HOCOCR2.BIT.HCFRQ = 0x2;	//HOCOg20 MHz: 0b10
	
	SYSTEM.HOCOCR.BIT.HCSTP = 0;	//HOCO
	
	while (SYSTEM.OSCOVFSR.BIT.HCOVF == 0) {
		// HOCO̔U肷܂ŉҋ@
	}
	
	SYSTEM.SCKCR3.BIT.CKSEL = 0x1;	//NbN\[XƂHOCOI: 0b001
	
	SYSTEM.PRCR.WORD = 0xA500;	//NbNH֘AWX^ւ̏݋֎~
}

//VXe
void main_init(void)
{
	init_clock_frequency();	//NbNg20MHzɂ
	
	//}CR@\̏
	timer_init();
	
	gpio_init();
	adc_init();
	
	i2c_init();
	
	lcd_init();
	serial_init();
	
	pwm_init();
	
	irq_init();
	pulse_counter_init();
	spi_init();
	
	//
	read_sw_init();
	reflect_sensor_init();
	distance_sensor_init();
	gyro_sensor_init();
	
	led_indicator_init();
	
	vehicle_control_main_init();
	
	uptime_1ms = 0;
	
	setpsw_i();			//荞݋
}

void main(void)
{
	UINT32 slot_count = 0;
	BYTE spi_result;

	main_init();
	/*test*/
	PORTD.PDR.BIT.B6 = 1;
	
	PORTD.PODR.BIT.B6 = 0;
	
	while(1){
		while(timer_1ms_pass == 0);
		timer_1ms_pass = 0; //tONA
		PORTD.PODR.BIT.B6 = ~PORTD.PODR.BIT.B6;
		
		uptime_1ms ++;
		
		//1msɂ火̏s
		spi_result = spi_read_data(0x8F);
		
		//UART0, UART6̃G[Ԃ`FbNA񕜂
		serial_check_recover_error_state();
		switch(slot_count){
		case 0:
			time_slot_0();
			break;
		case 1:
			time_slot_1();
			
			break;
		case 2:
			time_slot_2();
		
			break;
		case 3:
			time_slot_3();
			
			break;
		case 4:
			time_slot_4();
		
			break;
		case 5:
			time_slot_5();
			
			break;
		case 6:
			time_slot_6();
		
			break;
		case 7:
			time_slot_7();
			
			break;
		case 8:
			time_slot_8();
		
			break;
		case 9:
			time_slot_9();
			
			break;
		default:
			// no nothing
			break;
		}
		
		slot_count ++;
		if(slot_count >= SLOT_COUNT_MAX){
			slot_count = 0;
		}
		//PORTD.PODR.BIT.B6 = 0;

	}
	
}


UINT32 get_uptime(void)
{
	return(uptime_1ms);
}


#ifdef __cplusplus
void abort(void)
{

}
#endif
